# MarkdownAST

[![Version][juliahub-version-img]][juliahub-version-url]
[![Documentation][docs-stable-img]][docs-stable-url]
[![GitHub Actions CI][github-actions-img]][github-actions-url]
[![CodeCov][codecov-img]][codecov-url]
[![PkgEval][pkgeval-img]][pkgeval-url]

A Julia package for working with Markdown documents in an [abstract syntax tree][ast-wiki] representation.
As an example, the following Markdown

```markdown
# Markdown document

Hello [world](https://example.com/)!
```

can be represented as the following tree (in the [`@ast` macro DSL][mdast-astmacro]) using MarkdownAST

```julia
using MarkdownAST: @ast, Document, Heading, Paragraph, Link
ast = @ast Document() do
    Heading(1) do
        "Markdown document"
    end
    Paragraph() do
        "Hello "
        Link("https://example.com/", "") do
            "world"
        end
        "!"
    end
end
```

and the resulting [`Node` object][mdast-node] that contains information about the whole tree can be accessed, traversed, and, if need be, modified, e.g.

```julia-repl
julia> for node in ast.children
           println("$(node.element) with $(length(node.children)) child nodes")
       end
Heading(1) with 1 child nodes
Paragraph() with 3 child nodes
```

See the [documentation][docs-stable-url] for the full descriptions of the APIs that are available.

## Credits

The core parts of this package heavily derive from the [CommonMark.jl](https://github.com/MichaelHatherly/CommonMark.jl) package.
Also, this packages does not provide a parser, and the users are encouraged to check out CommonMark.jl for that purpose.


[juliahub-version-img]: https://juliahub.com/docs/MarkdownAST/version.svg
[juliahub-version-url]: https://juliahub.com/ui/Packages/MarkdownAST/6YkiC
[github-actions-img]: https://github.com/JuliaDocs/MarkdownAST.jl/actions/workflows/CI.yml/badge.svg
[github-actions-url]: https://github.com/JuliaDocs/MarkdownAST.jl/actions/workflows/CI.yml
[docs-stable-img]: https://img.shields.io/badge/documentation-stable-blue.svg
[docs-stable-url]: https://markdownast.juliadocs.org/stable/
[codecov-img]: https://codecov.io/gh/JuliaDocs/MarkdownAST.jl/branch/main/graph/badge.svg?token=91XPUAQ2WE
[codecov-url]: https://codecov.io/gh/JuliaDocs/MarkdownAST.jl
[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/M/MarkdownAST.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/M/MarkdownAST.html

[ast-wiki]: https://en.wikipedia.org/wiki/Abstract_syntax_tree
[mdast-astmacro]: https://markdownast.juliadocs.org/stable/astmacro/#MarkdownAST.@ast
[mdast-node]: https://markdownast.juliadocs.org/stable/node/#MarkdownAST.Node

# Conversion methods from the MarkdownAST representation to the Markdown standard library
# representation

"""
    convert(::Type{Markdown.MD}, node::Node) -> Markdown.MD

Converts a MarkdownAST representation of a Markdown document into the `Markdown` standard
library representation.

Note that the root node `node` must a [`Document`](@ref) element.
"""
function Base.convert(::Type{Markdown.MD}, node::Node)
    node.element isa Document || error("can only convert trees with Document() root element")
    return _convert_element(node)
end

_convert_element(n::Node) = _convert_element(n, n.element)
# Fallback for unknown element types
_convert_element(::Node, e::AbstractElement) =
    error("Unable to convert element of type $(typeof(e))\n  element = $(e)")

_convert_element(n::Node, ::Document) = Markdown.MD(_convert_element.(n.children))
# Block elements
_convert_element(n::Node, e::Admonition) = Markdown.Admonition(e.category, e.title, _convert_element.(n.children))
_convert_element(n::Node, ::BlockQuote) = Markdown.BlockQuote(_convert_element.(n.children))
_convert_element(::Node, e::CodeBlock) = Markdown.Code(e.info, e.code)
_convert_element(::Node, e::DisplayMath) = Markdown.LaTeX(e.math)
_convert_element(n::Node, e::FootnoteDefinition) = Markdown.Footnote(e.id, _convert_element.(n.children))
_convert_element(n::Node, e::Heading) = Markdown.Header{e.level}(_convert_element.(n.children))
_convert_element(n::Node, ::Paragraph) = Markdown.Paragraph(_convert_element.(n.children))
_convert_element(::Node, ::ThematicBreak) = Markdown.HorizontalRule()
# Inline elements
_convert_element(n::Node, ::Emph) = Markdown.Italic(_convert_element.(n.children))
_convert_element(::Node, e::Code) = Markdown.Code("", e.code)
_convert_element(::Node, e::FootnoteLink) = Markdown.Footnote(e.id, nothing)
function _convert_element(n::Node, e::Image)
    alt_text = strip(Markdown.plain(Markdown.Paragraph(_convert_element.(n.children))))
    Markdown.Image(e.destination, alt_text)
end
_convert_element(::Node, e::InlineMath) = Markdown.LaTeX(e.math)
_convert_element(::Node, e::JuliaValue) = e.ref
_convert_element(n::Node, e::Link) = Markdown.Link(_convert_element.(n.children), e.destination)
_convert_element(n::Node, ::Strong) = Markdown.Bold(_convert_element.(n.children))
@static if isdefined(Markdown, :Strikethrough)
    _convert_element(n::Node, ::Strikethrough) = Markdown.Strikethrough(_convert_element.(n.children))
else
    function _convert_element(::Node, ::Strikethrough)
        error("Unable to convert Strikethrough to Markdown stdlib on this Julia version")
    end
end
_convert_element(::Node, e::Text) = e.text
# Lists
_convert_element(n::Node, e::List) = Markdown.List(
    _convert_element.(n.children),
    (e.type == :bullet) ? -1 : 1,
    !e.tight,
)
_convert_element(n::Node, ::Item) = _convert_element.(n.children)
# Tables
function _convert_element(n::Node, e::Table)
    rows = map(Iterators.flatten(thtb.children for thtb in n.children)) do row
        @assert row.element isa TableRow
        _convert_element.(row.children)
    end
    ncols = maximum(length.(rows))
    align = rpad_array!(_invert_column_spec.(e.spec), ncols, :l)
    Markdown.Table(rows, align)
end
_convert_element(n::Node, ::TableCell) = _convert_element.(n.children)
_invert_column_spec(spec::Symbol) = Symbol(first(String(spec)))
# Whitespace nodes
_convert_element(n::Node, ::LineBreak) = Markdown.LineBreak()
_convert_element(n::Node, ::SoftBreak) = " "
_convert_element(n::Node, ::Backslash) = "\\"
# Raw HTML
@static if isdefined(Markdown, :HTMLBlock)
    _convert_element(::Node, e::HTMLBlock) = Markdown.HTMLBlock(split(e.html, '\n'; keepempty = true))
else
    _convert_element(::Node, e::HTMLBlock) = Markdown.Code("html", e.html)
end
@static if isdefined(Markdown, :HTMLInline)
    _convert_element(::Node, e::HTMLInline) = Markdown.HTMLInline(e.html)
else
    _convert_element(::Node, e::HTMLInline) = Markdown.Code("", e.html)
end

using MarkdownAST
using MarkdownAST: AbstractElement, AbstractBlock, AbstractInline,
    Document,
    Admonition, BlockQuote, CodeBlock, DisplayMath, FootnoteDefinition, HTMLBlock, Heading,
    Item, List, Paragraph, ThematicBreak,
    Code, Emph, FootnoteLink, HTMLInline, Image, InlineMath, Link, Strong, Strikethrough, JuliaValue,
    TableComponent, Table, TableHeader, TableBody, TableRow, TableCell,
    LineBreak, SoftBreak, Backslash,
    iscontainer, can_contain, isblock, isinline
using Test

# To test the various can_contain etc. relationships, we'll define two pseudo-elements with
# default behaviours that we can use in the tests later on:
struct PseudoBlock <: AbstractBlock
    iscontainer :: Bool
end
MarkdownAST.iscontainer(e::PseudoBlock) = e.iscontainer
struct PseudoInline <: AbstractInline
    iscontainer :: Bool
end
MarkdownAST.iscontainer(e::PseudoInline) = e.iscontainer

@testset "Markdown AST" begin
    # Check that the pseudo-elements make sense:
    @test iscontainer(PseudoBlock(true))
    @test isblock(PseudoBlock(true))
    @test ! isinline(PseudoBlock(true))

    @test ! iscontainer(PseudoBlock(false))
    @test isblock(PseudoBlock(false))
    @test ! isinline(PseudoBlock(false))

    @test iscontainer(PseudoInline(true))
    @test ! isblock(PseudoInline(true))
    @test isinline(PseudoInline(true))

    @test ! iscontainer(PseudoInline(false))
    @test ! isblock(PseudoInline(false))
    @test isinline(PseudoInline(false))

    # Elements come in broadly five different categories:
    #
    # 1. Blocks that contain other blocks.
    # 2. Blocks that contain inlines.
    # 3. Block leafs.
    # 4. Inlines that contain inlines.
    # 5. Inline leafs.
    #
    # First, (1) blocks that contain other blocks:
    for e in [
        Document(), Admonition("category", "title"), BlockQuote(), FootnoteDefinition("id"),
    ]
        @test iscontainer(e)
        @test isblock(e)
        @test ! isinline(e)
        @test can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(false))
        @test can_contain(PseudoBlock(true), e)
        @test ! can_contain(PseudoInline(true), e)
    end
    # (2) blocks that contain inlines
    @test_throws Exception Heading(0)
    @test_throws Exception Heading(-100)
    @test_throws Exception Heading(7)
    @test_throws Exception Heading("100")
    @test_throws Exception Heading(6.234im)
    for e in [Heading(1), Paragraph()]
        @test iscontainer(e)
        @test isblock(e)
        @test ! isinline(e)
        @test ! can_contain(e, PseudoBlock(false))
        @test can_contain(e, PseudoInline(false))
        @test can_contain(PseudoBlock(true), e)
        @test ! can_contain(PseudoInline(true), e)
    end
    # (3) leaf blocks
    for e in [
        CodeBlock("info", "code"), DisplayMath("math"), HTMLBlock("html"), ThematicBreak()
    ]
        @test ! iscontainer(e)
        @test isblock(e)
        @test ! isinline(e)
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(false))
        @test can_contain(PseudoBlock(true), e)
        @test ! can_contain(PseudoInline(true), e)
    end

    # (4) Inlines containing inlines:
    for e in [Link("url", "title"), Image("url", "title"), Emph(), Strong(), Strikethrough()]
        @test iscontainer(e)
        @test ! isblock(e)
        @test isinline(e)
        @test ! can_contain(e, PseudoBlock(false))
        @test can_contain(e, PseudoInline(false))
        @test ! can_contain(PseudoBlock(true), e)
        @test can_contain(PseudoInline(true), e)
    end
    # (5) Inline leafs:
    for e in [
        Code("code"), FootnoteLink("id"), HTMLInline("html"), InlineMath("math"),
        MarkdownAST.Text("text"), JuliaValue(:(x^2), 4),
    ]
        @test ! iscontainer(e)
        @test ! isblock(e)
        @test isinline(e)
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(false))
        @test ! can_contain(PseudoBlock(true), e)
        @test can_contain(PseudoInline(true), e)
    end
    for e in [
        Backslash(), SoftBreak(), LineBreak(),
    ]
        @test ! iscontainer(e)
        @test ! isblock(e)
        @test isinline(e)
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(false))
        @test ! can_contain(PseudoBlock(true), e)
        @test can_contain(PseudoInline(true), e)
    end

    # Lists are special
    let e = List(:bullet, true)
        @test iscontainer(e)
        @test can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test can_contain(e, Item())
        @test ! can_contain(e, PseudoBlock(true))
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(true))
        @test ! can_contain(e, PseudoInline(false))
    end
    let e = Item()
        @test iscontainer(e)
        # Since Item <: AbstractBlock, it can be contained in any element that
        # can contain blocks, including other Items..
        @test_broken ! can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test_broken ! can_contain(e, Item())
        @test can_contain(e, PseudoBlock(true))
        @test can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(true))
        @test ! can_contain(e, PseudoInline(false))
    end

    # Tables
    let e = Table([])
        @test iscontainer(e)
        @test can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test can_contain(e, TableHeader())
        @test can_contain(e, TableBody())
        @test ! can_contain(e, TableRow())
        @test ! can_contain(e, TableCell(:c, true, 1))
        @test ! can_contain(e, PseudoBlock(true))
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(true))
        @test ! can_contain(e, PseudoInline(false))
    end
    for e = [TableHeader(), TableBody()]
        @test iscontainer(e)
        # Because all TableComponents are AbstractBlocks, we can actually put
        # them in arbitrary nodes that can contain blocks..
        @test_broken ! can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test ! can_contain(e, TableHeader())
        @test ! can_contain(e, TableBody())
        @test can_contain(e, TableRow())
        @test ! can_contain(e, TableCell(:c, true, 1))
        @test ! can_contain(e, PseudoBlock(true))
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(true))
        @test ! can_contain(e, PseudoInline(false))
    end
    let e = TableRow()
        @test iscontainer(e)
        # Because all TableComponents are AbstractBlocks, we can actually put
        # them in arbitrary nodes that can contain blocks..
        @test_broken ! can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test ! can_contain(e, TableHeader())
        @test ! can_contain(e, TableBody())
        @test ! can_contain(e, TableRow())
        @test can_contain(e, TableCell(:c, true, 1))
        @test ! can_contain(e, PseudoBlock(true))
        @test ! can_contain(e, PseudoBlock(false))
        @test ! can_contain(e, PseudoInline(true))
        @test ! can_contain(e, PseudoInline(false))
    end
    let e = TableCell(:c, true, 1)
        @test iscontainer(e)
        # Because all TableComponents are AbstractBlocks, we can actually put
        # them in arbitrary nodes that can contain blocks..
        @test_broken ! can_contain(Document(), e)
        @test ! can_contain(Paragraph(), e)
        @test ! can_contain(e, TableHeader())
        @test ! can_contain(e, TableBody())
        @test ! can_contain(e, TableRow())
        @test ! can_contain(e, TableCell(:c, true, 1))
        @test ! can_contain(e, PseudoBlock(true))
        @test ! can_contain(e, PseudoBlock(false))
        @test can_contain(e, PseudoInline(true))
        @test can_contain(e, PseudoInline(false))
    end
    @test_throws ErrorException Table([:foo])
end

"""
    @ast markdown-node-expression

A macro that implements a simple domain specific language to easily and explicitly construct
a Markdown AST.

The `markdown-node-expression` must be either:

1. A Markdown element (i.e. some [`AbstractElement`](@ref MarkdownAST.AbstractElement) object),
   such as a constructor call (e.g. `Paragraph()`), function call returning an element, or a
   variable pointing to an element.

2. A variable or an expression returning or pointing to a `Node` object, which will then get
   unlinked from its current tree and pushed as a child (together with all of its descendents).

3. A `do`-block, with the function call part being an element (as above), and the contents
   of the `do`-block a sequence of other node expressions, i.e.

   ```julia
   element do
       child-node-expression-1
       child-node-expression-2
       ...
   end
   ```

In practice, a simple example might look something like

```julia
@ast Document() do
    Heading(1) do
        "Top-level heading"
    end
    Paragraph() do
        "Some paragraph text"
    end
end
```

Strings are interpreted as `Text(s)` elements.
"""
macro ast(expr)
    # First, we convert the Julia AST into nested tuples, for easier parsing:
    ast = astify(expr)
    # And now we parse the tuples, to construct an expression that can actually construct
    # the Node object corresponding to this AST.
    ast_expression(ast...)
end

# TODO: add a 2-argument @ast to be consistent with the Node{M}(...) printing in show(), i.e.
#
#   @ast M markdown-node-expression
#
# Should construct Node(element, M()) nodes.

function astify(expr::Expr)
    # do-expressions are special, but in other cases we just assume the expression is some
    # user code that should be evaluated and it returns a container object (or a string).
    expr.head === :do || return (expr, [])
    # The following assumes we're dealing with a do-expression
    @assert expr.head === :do
    container = expr.args[1]
    # args[2] of a do-block should be a lambda function
    dobody = let expr = expr.args[2]
        @assert expr isa Expr
        @assert expr.head === :(->)
        # Make sure that there are not arguments passed for the do-synta
        @assert expr.args[1] isa Expr
        @assert expr.args[1].head === :tuple
        @assert isempty(expr.args[1].args) # TODO: informative error
        # args[2] of the do-block lambda function is the actual body of the lambda function,
        # i.e. the contents of the do-block itself
        @assert expr.args[2] isa Expr
        @assert expr.args[2].head === :block
        expr.args[2]
    end
    # Extract the children node from the do-block body
    children = Any[]
    for arg in dobody.args
        arg isa LineNumberNode && continue # metadata, can be ignored
        push!(children, astify(arg))
    end
    # We always return a (node, [children]) tuple
    return (container, children)
end
astify(arg::Symbol) = (arg, []) # variable
astify(arg::AbstractString) = (arg, []) # string literal

function ast_expression(container, children)
    parent_node_expr = container_node_expr(container)
    isempty(children) && return parent_node_expr
    # else:
    children_expr = Expr(:tuple)
    for c in children
        push!(children_expr.args, ast_expression(c...))
    end
    quote
        let n = $(parent_node_expr)
            for c in $(children_expr)
                push!(n.children, c)
            end
            n
        end
    end
end

function container_node_expr(container)
    quote
        let c = $(esc(container))
            if c isa AbstractString
                Node(Text(c))
            elseif c isa Node
                c
            else
                Node(c)
            end
        end
    end
end

using MarkdownAST, AbstractTrees
using Documenter
import Markdown # necessary to reference stdlib in at-docs signatures

makedocs(
    sitename = "MarkdownAST",
    pages = [
        "Introduction" => "index.md",
        "elements.md",
        "node.md",
        "astmacro.md",
        "iteration.md",
        "Conversion to/from `Markdown`" => "stdlib.md",
    ],
    # documentation checks
    modules = [MarkdownAST],
    checkdocs = :all,
)

deploydocs(
    repo = "github.com/JuliaDocs/MarkdownAST.jl.git",
)

using MarkdownAST: MarkdownAST, Node, @ast, Document,
    Emph, Strong, Strikethrough, InlineMath, Link, Code, Image,
    Paragraph, Heading, CodeBlock, BlockQuote, DisplayMath, ThematicBreak,
    List, Item, FootnoteLink, FootnoteDefinition, Admonition,
    Table, TableHeader, TableBody, TableRow, TableCell,
    JuliaValue, LineBreak, Backslash, SoftBreak,
    HTMLBlock, HTMLInline
using Markdown: Markdown
using Test

struct UnknownBlock <: MarkdownAST.AbstractBlock end

@testset "Conversion to Markdown stdlib" begin
    @test_throws ErrorException convert(Markdown.MD, @ast Paragraph())
    @test_throws ErrorException convert(Markdown.MD, @ast "...")
    @test convert(Markdown.MD, @ast Document()) isa Markdown.MD

    let ast = @ast Document() do
            UnknownBlock()
        end
        @test_throws ErrorException convert(Markdown.MD, ast)
    end

    let ast = @ast Document() do
            Heading(1) do; "heading 1"; end
            Heading(2)
            Heading(3) do; "heading 3"; end
            Heading(4) do; "heading 4"; end
            Heading(5) do; "heading 5"; end
            Heading(6) do; "heading 6"; end
        end
        md = convert(Markdown.MD, ast)
        @test md isa Markdown.MD
        @test length(md.content) == 6
        for i = 1:6
            @test md.content[i] isa Markdown.Header{i}
            if i == 2
                @test isempty(md.content[i].text)
            else
                @test md.content[i].text == ["heading $i"]
            end
        end
        @test convert(Node, md) == ast
    end

    let ast = @ast Document() do
            Paragraph() do
                "foo "
                Emph()
                Strong() do
                    Emph() do; "bar "; end
                    "baz"
                end
            end
            Paragraph()
            BlockQuote() do
                Paragraph() do; "foo"; end
            end
        end
        md = convert(Markdown.MD, ast)
        @test md isa Markdown.MD
        @test length(md.content) == 3
        @test md.content[1] isa Markdown.Paragraph
        @test md.content[2] isa Markdown.Paragraph
        @test md.content[3] isa Markdown.BlockQuote
        @test length(md.content[1].content) == 3
        @test length(md.content[3].content) == 1
        @test md.content[1].content[1] == "foo "
        @test md.content[1].content[2] isa Markdown.Italic
        @test md.content[1].content[3] isa Markdown.Bold
        @test length(md.content[1].content[3].text) == 2
        @test md.content[1].content[3].text[1] isa Markdown.Italic
        @test md.content[1].content[3].text[2] == "baz"
        @test convert(Node, md) == ast
    end

    let ast = @ast Document() do
            Heading(1) do; "Heading!"; end
            Admonition("warning", "Warning admonition !") do
                Paragraph() do; "..."; end
            end
            CodeBlock("julia", "versioninfo()")
            DisplayMath("x^2")
            ThematicBreak()
            Paragraph() do
                Code("y = f(x)")
                InlineMath("y = f(x)")
            end
        end
        md = convert(Markdown.MD, ast)
        @test ast == convert(Node, md)
    end

    let ast = @ast Document() do
            Paragraph() do
                "pre "
                Strikethrough() do; "mid"; end
                " post"
            end
        end
        if isdefined(Markdown, :Strikethrough)
            md = convert(Markdown.MD, ast)
            @test md.content[1].content[2] isa Markdown.Strikethrough
            @test convert(Node, md) == ast
        else
            @test_throws ErrorException convert(Markdown.MD, ast)
        end
    end

    # JuliaValue
    let ast = @ast Document() do
            Paragraph() do
                JuliaValue(:x, 42)
                JuliaValue(43, 43)
                JuliaValue(:y, nothing)
            end
        end
        md = convert(Markdown.MD, ast)
        # When converting to Markdown, the original expression of JuliaValue
        # gets lost.
        @test convert(Node, md) == @ast Document() do
            Paragraph() do
                JuliaValue(nothing, 42)
                JuliaValue(nothing, 43)
                JuliaValue(nothing, nothing)
            end
        end
    end

    # Footnotes
    let ast = @ast MarkdownAST.Document() do
            MarkdownAST.Paragraph() do
                "Text"
                MarkdownAST.FootnoteLink("note")
                "."
            end
            MarkdownAST.FootnoteDefinition("note") do
                MarkdownAST.Paragraph() do; "Note this"; end
            end
        end
        md = convert(Markdown.MD, ast)
        @test convert(Node, md) == ast
    end

    # Links and images
    let ast = @ast MarkdownAST.Document() do
            MarkdownAST.Paragraph() do
                MarkdownAST.Link("url", "title") do
                    MarkdownAST.Text("foo")
                    MarkdownAST.Strong() do; "bar"; end
                end
                MarkdownAST.Image("url", "title") do
                    MarkdownAST.Text("foo")
                    MarkdownAST.Strong() do; "bar"; end
                end
            end
        end
        md = convert(Markdown.MD, ast)
        # The .title attribute gets lost because Markdown does not store that information.
        # Also, the Markdown.Image element does not store the link contents as AST, but
        # just as a plain string. So when converting from MarkdownAST, we turn the internals
        # into a string with Markdown.plain().
        @test convert(Node, md) == @ast MarkdownAST.Document() do
            MarkdownAST.Paragraph() do
                MarkdownAST.Link("url", "") do
                    MarkdownAST.Text("foo")
                    MarkdownAST.Strong() do
                    MarkdownAST.Text("bar")
                    end
                end
                MarkdownAST.Image("url", "") do
                    MarkdownAST.Text("foo**bar**")
                end
            end
        end
    end

    # Lists
    let ast = @ast Document() do
            List(:ordered, true) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:ordered, false) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:bullet, true) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:bullet, false) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
        end
        md = convert(Markdown.MD, ast)
        @test convert(Node, md) == @ast Document() do
            List(:ordered, true) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:ordered, false) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:bullet, true) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
            List(:bullet, false) do
                Item() do; Paragraph() do; "foo"; end; end
                Item() do; Paragraph() do; "bar"; end; end
            end
        end
    end

    # Tables
    @test MarkdownAST._invert_column_spec(:left) === :l
    @test MarkdownAST._invert_column_spec(:right) === :r
    @test MarkdownAST._invert_column_spec(:center) === :c
    @test MarkdownAST._invert_column_spec(:foo) === :f
    let ast = @ast Document() do
            Table([:left, :right, :center]) do
                TableHeader() do
                    TableRow() do
                        TableCell(:left,   true, 1) do; "1,1"; end
                        TableCell(:right,  true, 2) do; "1,2"; end
                        TableCell(:center, true, 3) do; "1,3"; end
                    end
                end
                TableBody() do
                    TableRow() do
                        TableCell(:left,   false, 1) do; "2,1"; end
                        TableCell(:right,  false, 2) do; "2,2"; end
                        TableCell(:center, false, 3) do; "2,3"; end
                    end
                    TableRow() do
                        TableCell(:left,   false, 1) do; "3,1"; end
                        TableCell(:right,  false, 2) do; "3,2"; end
                        TableCell(:center, false, 3) do; "3,3"; end
                    end
                end
            end
        end
        md = convert(Markdown.MD, ast)
        @test convert(Node, md) == ast
    end
    # TODO: should also tests tables that are problematic

    # Whitespace
    let ast = @ast MarkdownAST.Document() do
            Paragraph() do
                "foo"
                LineBreak()
                "bar"
                SoftBreak()
                Backslash()
                "baz"
            end
        end
        md = convert(Markdown.MD, ast)
        # Markdown does not have SoftBreak nor backslash nodes, so they get replaced
        # with the corresponding strings / text nodes.
        @test convert(Node, md) == @ast MarkdownAST.Document() do
            Paragraph() do
                "foo"
                LineBreak()
                "bar"
                " "
                "\\"
                "baz"
            end
        end
    end

    # HTML elements
    let ast = @ast MarkdownAST.Document() do
            HTMLBlock("<html>")
            Paragraph() do; HTMLInline("</html>"); end
        end
        md = convert(Markdown.MD, ast)
        if isdefined(Markdown, :HTMLBlock)
            @test md.content[1] isa Markdown.HTMLBlock
        else
            @test md.content[1] isa Markdown.Code
        end
        if isdefined(Markdown, :HTMLInline)
            @test md.content[2].content[1] isa Markdown.HTMLInline
        else
            @test md.content[2].content[1] isa Markdown.Code
        end
        if isdefined(Markdown, :HTMLBlock)
            if isdefined(Markdown, :HTMLInline)
                @test convert(Node, md) == @ast MarkdownAST.Document() do
                    HTMLBlock("<html>")
                    Paragraph() do; HTMLInline("</html>"); end
                end
            else
                @test convert(Node, md) == @ast MarkdownAST.Document() do
                    HTMLBlock("<html>")
                    Paragraph() do; Code("</html>"); end
                end
            end
        else
            if isdefined(Markdown, :HTMLInline)
                @test convert(Node, md) == @ast MarkdownAST.Document() do
                    CodeBlock("html", "<html>")
                    Paragraph() do; HTMLInline("</html>"); end
                end
            else
                # Markdown can't represent raw HTML, so it gets converted into
                # Code nodes instead.
                @test convert(Node, md) == @ast MarkdownAST.Document() do
                    CodeBlock("html", "<html>")
                    Paragraph() do; Code("</html>"); end
                end
            end
        end
    end
end

using MarkdownAST: MarkdownAST,
    Node, haschildren, @ast, copy_tree, unlink!,
    Document, Paragraph, Strong, Link, BlockQuote, CodeBlock, HTMLBlock, Heading, Code, DisplayMath,
    NodeChildren
using Test

# Compat-ish.. startswith(prefix) was added in 1.5:
_startswith(prefix) = s -> startswith(s, prefix)


# For `replace`: replace link with its children -- cf. docstring of `replace`,
# but for the test we'll do something fancier by combining it with the
# `_flatten_text` below.
function _remove_link(node)
    if (node isa Node) && (node.element isa MarkdownAST.Link)
        return [copy_tree(child) for child in node.children]
    else
        return node
    end
end

# For `replace`: combine consecutive `Text` children in paragraph
function _flatten_text(node)
    if (node isa Node) && (node.element isa MarkdownAST.Paragraph)
        new_paragraph = typeof(node)(node.element, deepcopy(node.meta))
        node = copy_tree(node)  # so we can unlink children without mutating
        push!(new_paragraph.children, first(node.children))
        while haschildren(node)
            child = first(node.children)
            if child.element isa MarkdownAST.Text
                last_child = last(new_paragraph.children)
                if last_child.element isa MarkdownAST.Text
                    last_child.element.text *= child.element.text
                    unlink!(child)
                else
                    push!(new_paragraph.children, child)
                end
            else
                push!(new_paragraph.children, child)
            end
        end
        return new_paragraph
    else
        return node
    end
end


@testset "Node" begin
    # Basic constructors
    @test Node(Document()) isa Node{Nothing}
    @test_throws MethodError Node(Document(), nothing)
    @test_throws MethodError Node(Document(), 1)
    @test Node{Int}(Document(), 1) isa Node{Int}

    # Make sure that we discard the {Nothing} type parameter for the "standard"
    # node when printing:
    @test repr(Node(Document())) |> _startswith("@ast Document()")
    # note: interpolating Int because it's an alias, and is actually 'Int64'
    @test repr(Node{Int}(Document(), 1)) |> _startswith("@ast Int64 Document()")

    # Accessing the container of the node:
    let n = Node(Document())
        @test n.element isa Document
        @test_throws TypeError n.element = 2
        n.element = MarkdownAST.Text("...")
        @test n.element isa MarkdownAST.Text
    end

    # Construct a simple tree:
    root = Node(Document())
    # Test various accessor methods on an isolated node:
    @test root.parent === nothing
    @test root.next === nothing
    @test root.next === nothing
    @test length(root.children) == 0
    @test all(collect(root.children) .=== Node[])
    @test haschildren(root) === false
    let n1 = Node(Paragraph())
        @test push!(root.children, n1) == root.children
        @test length(root.children) == 1
        @test all(collect(root.children) .=== Node[n1])
        @test haschildren(root) === true
        @test haschildren(n1) === false
        # Add another child
        n2 = Node(HTMLBlock(""))
        @test push!(root.children, n2) == root.children
        @test length(root.children) == 2
        @test all(collect(root.children) .=== Node[n1, n2])
        # Push the first child again. This should unlink it from the original
        # position.
        @test push!(root.children, n1) == root.children
        @test length(root.children) == 2
        @test all(collect(root.children) .=== Node[n2, n1])
        # Same as before, but for pushfirst!
        n3 = Node(Paragraph())
        @test pushfirst!(root.children, n3) == root.children
        @test length(root.children) == 3
        @test all(collect(root.children) .=== Node[n3, n2, n1])
        # Unlinking with pushfirst!
        @test pushfirst!(root.children, n2) == root.children
        @test length(root.children) == 3
        @test all(collect(root.children) .=== Node[n2, n3, n1])
        # Make sure we can't push! to Node
        @test_throws MarkdownAST.UnimplementedMethodError push!(root, n1)
        @test_throws MarkdownAST.UnimplementedMethodError pushfirst!(root, n1)
    end

    # Equality of simple nodes:
    @test Node(Document()) == Node(Document())
    @test Node(Document()) != Node(Paragraph())
    @test Node{Int}(Document(), 10) == Node{Int}(Document(), 10)
    @test Node{Int}(Document(), 10) != Node{Int}(Document(), 11)
    @test Node{Int}(Document(), 10) != Node(Document())
    @test Node(MarkdownAST.Text("")) == Node(MarkdownAST.Text(""))
    @test Node(MarkdownAST.Text("x")) == Node(MarkdownAST.Text("x"))
    @test Node(MarkdownAST.Text("x")) != Node(MarkdownAST.Text("y"))
    @test Node(Link("x", "y")) == Node(Link("x", "y"))
    @test Node(Link("x", "y")) != Node(Link("x", "z"))

    # Constructing trees with the @ast macro
    let
        stringvar = "bar"
        containervar = CodeBlock("lang", "code()")
        tree = @ast Document() do
            Heading(1) do
                "Foo"
            end
            Paragraph() do
                stringvar
                "Foo"
                MarkdownAST.Text(stringvar) # call expr
            end
            containervar
        end
        @test tree.element isa Document
        @test length(tree.children) == 3
        @test haschildren(tree) === true
        # Check the children:
        cs = collect(tree.children)
        # first child
        @test cs[1].element isa Heading
        @test length(cs[1].children) == 1
        @test cs[1].parent === tree
        @test cs[1].previous === nothing
        @test cs[1].next === cs[2]
        # second child
        @test cs[2].element isa Paragraph
        @test length(cs[2].children) == 3
        @test cs[2].parent === tree
        @test cs[2].previous === cs[1]
        @test cs[2].next === cs[3]
        let cs = collect(cs[2].children)
            @test cs[1].element isa MarkdownAST.Text
            @test cs[2].element isa MarkdownAST.Text
            @test cs[3].element isa MarkdownAST.Text
            @test cs[1].element.text == "bar"
            @test cs[2].element.text == "Foo"
            @test cs[3].element.text == "bar"
        end
        # third child
        @test cs[3].element isa CodeBlock
        @test haschildren(cs[3]) === false
        @test length(cs[3].children) == 0
        @test cs[3].parent === tree
        @test cs[3].previous === cs[2]
        @test cs[3].next === nothing
    end

    # Equality of more complex trees:
    @test (@ast Paragraph() do; "foo"; end) == (@ast Paragraph() do; "foo"; end)
    @test (@ast Paragraph() do; "foo"; end) != (@ast Paragraph() do; "bar"; end)
    @test (@ast Paragraph() do; end) != (@ast Paragraph() do; "foo"; end)
    @test (@ast Strong() do; "foo"; end) == (@ast Strong() do; "foo"; end)
    @test (@ast Strong() do; "foo"; end) != (@ast Paragraph() do; "foo"; end)

    x = @ast Document() do
        Paragraph() do
            "foo"
        end
        Paragraph() do
            "bar"
        end
    end
    y = @ast Document() do
        Paragraph() do
            "foo"
        end
        Paragraph() do
            "bar"
        end
    end
    z = @ast Document() do
        Paragraph() do
            "foo"
        end
        Paragraph() do
            "baz"
        end
    end
    @test x == x; @test y == y; @test z == z
    @test x !== y; @test x == y; @test y == x
    @test x !== y; y !== z
    @test x != z; @test y != z

    # Different number of children:
    x = @ast Paragraph() do
        Link("", "") do
            "link"
        end
        "foo"
    end
    y = @ast Paragraph() do
        Link("", "") do
            "link"
        end
    end
    @test x != y
    @test first(x.children) !== first(y.children)
    @test first(x.children) == first(y.children)

    n = @ast Paragraph() do
        "foo-"
        Strong() do; "bar: "; Code("baz"); end
    end
    @test repr(n) == """
    @ast Paragraph() do
      MarkdownAST.Text("foo-")
      Strong() do
        MarkdownAST.Text("bar: ")
        Code("baz")
      end
    end
    """

    # append! and prepend!
    n = @ast Document() do
        DisplayMath("")
        DisplayMath("")
    end
    cs = Node.([Paragraph(), CodeBlock("", ""), BlockQuote()])
    @test append!(n.children, cs) isa NodeChildren
    @test typeof.(getproperty.(n.children, :element)) == [DisplayMath, DisplayMath, Paragraph, CodeBlock, BlockQuote]
    @test prepend!(n.children, cs) isa NodeChildren
    @test typeof.(getproperty.(n.children, :element)) == [Paragraph, CodeBlock, BlockQuote, DisplayMath, DisplayMath]
    # test, but with a generic iterator
    @test append!(n.children, c for c in cs) isa NodeChildren
    @test typeof.(getproperty.(n.children, :element)) == [DisplayMath, DisplayMath, Paragraph, CodeBlock, BlockQuote]
    # test, but with elements from NodeChildren iterator
    n2 = @ast Document() do
        Heading(1)
    end
    @test append!(n2.children, n.children) isa NodeChildren
    @test typeof.(getproperty.(n2.children, :element)) == [Heading, DisplayMath, DisplayMath, Paragraph, CodeBlock, BlockQuote]
    @test isempty(n.children)
    n3 = @ast Document() do
        Heading(1)
    end
    @test prepend!(n3.children, n2.children) isa NodeChildren
    @test typeof.(getproperty.(n3.children, :element)) == [Heading, DisplayMath, DisplayMath, Paragraph, CodeBlock, BlockQuote, Heading]
    @test isempty(n2.children)

    # empty!
    @test length(n3.children) == 7
    empty_children = empty!(n3.children)
    @test isempty(n3.children)
    @test empty_children === n3.children

    # replace and replace!
    n = @ast MarkdownAST.Document() do
      MarkdownAST.Heading(1) do
        MarkdownAST.Text("Title")
      end
      MarkdownAST.Paragraph() do
        MarkdownAST.Text("This is a paragraph with a ")
        MarkdownAST.Link("#title", "") do
          MarkdownAST.Text("link with ")
          MarkdownAST.Code("code")
          MarkdownAST.Text(", ")
          MarkdownAST.InlineMath("math")
          MarkdownAST.Text(", and ")
          MarkdownAST.Emph() do
            MarkdownAST.Text("italics")
          end
          MarkdownAST.Text(" in its description")
        end
        MarkdownAST.Text(".")
      end
      MarkdownAST.Paragraph() do
        MarkdownAST.Text("There's a second paragraph with another ")
        MarkdownAST.Link("#title", "") do
          MarkdownAST.Text("link")
        end
        MarkdownAST.Text(".")
      end
      MarkdownAST.Paragraph() do
        MarkdownAST.Text("This concludes the document.")
      end
    end
    orig_n = copy_tree(n)
    n2 = replace(_flatten_text ∘ _remove_link, n)
    @test !(n2 === n)
    @test n == orig_n  # didn't mutate original
    @test n2 == @ast Document() do
      Heading(1) do
        MarkdownAST.Text("Title")
      end
      Paragraph() do
        MarkdownAST.Text("This is a paragraph with a link with ")
        Code("code")
        MarkdownAST.Text(", ")
        MarkdownAST.InlineMath("math")
        MarkdownAST.Text(", and ")
        MarkdownAST.Emph() do
          MarkdownAST.Text("italics")
        end
        MarkdownAST.Text(" in its description.")
      end
      Paragraph() do
        MarkdownAST.Text("There's a second paragraph with another link.")
      end
      Paragraph() do
        MarkdownAST.Text("This concludes the document.")
      end
    end
    # Call `replace` just on the second paragraph
    p = replace(_flatten_text ∘ _remove_link, first(n.children).next.next)
    @test p.parent === nothing
    # Note that _flatten_text didn't have any effect because `replace` doesn't
    # touch the root node (but it did replace the link)
    @test p == @ast Paragraph() do
      MarkdownAST.Text("There's a second paragraph with another ")
      MarkdownAST.Text("link")
      MarkdownAST.Text(".")
    end
    p2 = replace!(_flatten_text ∘ _remove_link, first(n.children).next.next)
    @test !(p2 === p)
    @test p2 == p
    # We've replaced the 2nd paragraph in-place, so the result will show up in `n`
    @test n == @ast Document() do
      Heading(1) do
        MarkdownAST.Text("Title")
      end
      Paragraph() do
        MarkdownAST.Text("This is a paragraph with a ")
        Link("#title", "") do
          MarkdownAST.Text("link with ")
          Code("code")
          MarkdownAST.Text(", ")
          MarkdownAST.InlineMath("math")
          MarkdownAST.Text(", and ")
          MarkdownAST.Emph() do
            MarkdownAST.Text("italics")
          end
          MarkdownAST.Text(" in its description")
        end
        MarkdownAST.Text(".")
      end
      Paragraph() do
        MarkdownAST.Text("There's a second paragraph with another ")
        MarkdownAST.Text("link")
        MarkdownAST.Text(".")
      end
      Paragraph() do
        MarkdownAST.Text("This concludes the document.")
      end
    end
    replace!(_flatten_text ∘ _remove_link, n)
    # We've now replaced the rest of `n` in-place, so we should get the same
    # final result as for `n2 = replace(..., n)`.
    @test !(n === n2)
    @test n == n2
    # Test check for invalid `f` (must return Node or Vector of nodes)
    @test_throws ArgumentError begin
        replace(n) do node
            if node.element isa MarkdownAST.InlineMath
                return nothing
            else
                return node
            end
        end
    end

    # @ast macro with variables and function calls
    inner_tree = @ast Paragraph() do; "foo"; end
    el(x) = x ? Document() : BlockQuote()
    interp_tree = @ast el(true) do
        Paragraph()
        inner_tree
        el(false)
    end
    @test interp_tree == @ast Document() do
        Paragraph()
        Paragraph() do
            "foo"
        end
        BlockQuote()
    end
end

# This example shows how to construct a simple Markdown AST with the help of the @ast macro
using MarkdownAST: MarkdownAST, @ast, Document, Paragraph, Heading, Link

doc = @ast Document() do
    Heading(1) do
        "Example document"
    end
    Paragraph() do
        "Text "
        Link("foo/", "") do
            "link"
        end
        " and more text."
    end
end

# The AST can be written back into the standard output with the showast function.
# The print representation mirrors the @ast macro.
MarkdownAST.showast(doc)

using MarkdownAST: MarkdownAST, copy_tree, tablerows, tablesize,
    Node, Table, TableHeader, TableBody, TableRow, TableCell,
    InvalidChildException
using Test

@testset "Tools" begin
    # copy_tree
    x0 = @ast Paragraph() do
        Link("", "") do
            "link"
        end
        "foo"
    end
    x1 = copy_tree(x0)
    @test x1 == x0
    @test x1 !== x0
    x2 = copy_tree(first(x0.children))
    @test x2.element isa Link
    x3 = copy_tree(x0) do node, element
        @test node.element === element
        if node.element isa MarkdownAST.Text
            Code(node.element.text)
        else
            deepcopy(node.element)
        end
    end
    @test x3 != x0
    @test first(x3.children).next.element isa Code

    @test_throws InvalidChildException copy_tree(x0) do node, element
        element isa Link ? Paragraph() : element
    end

    # Table helper functions
    @test_throws ErrorException tablerows(Node(Document()))
    @test_throws ErrorException tablesize(Node(Document()))
    c = TableCell(:right, true, 0)
    table = @ast Table([]) do
        TableHeader() do
            TableRow() do; c; c; c end
        end
        TableBody() do
            TableRow()
            TableRow() do; c; end
            TableRow() do; c; c; c; c; c; c; c; end
            TableRow() do; c; c; end
        end
    end
    let rows = collect(tablerows(table))
        @test length(rows) == 5
        @test rows[1] == first(first(table.children).children)
        @test rows[2] == first(last(table.children).children)
        @test rows[3] == first(last(table.children).children).next
        @test rows[4] == first(last(table.children).children).next.next
        @test rows[5] == first(last(table.children).children).next.next.next
    end
    @test tablesize(table) == (5, 7)
    @test tablesize(table, 1) == 5
    @test tablesize(table, 2) == 7
    @test_throws ErrorException tablesize(table, 0)
    @test_throws ErrorException tablesize(table, 3)

    table = @ast Table([]) do
        TableHeader()
        TableBody() do
            TableRow()
            TableRow() do; c; end
            TableRow() do; c; c; c; c; c; c; c; end
            TableRow() do; c; c; end
        end
    end
    let rows = collect(tablerows(table))
        @test length(rows) == 4
        @test rows[1] == first(last(table.children).children)
        @test rows[2] == first(last(table.children).children).next
        @test rows[3] == first(last(table.children).children).next.next
        @test rows[4] == first(last(table.children).children).next.next.next
    end
    @test tablesize(table) == (4, 7)

    table = @ast Table([]) do
        TableHeader() do
            TableRow() do; c; c; c end
            TableRow()
            TableRow() do; c; end
            TableRow() do; c; c; c; c; c; c; c; end
            TableRow() do; c; c; end
        end
        TableBody()
    end
    let rows = collect(tablerows(table))
        @test length(rows) == 5
        @test rows[1] == first(first(table.children).children)
        @test rows[2] == first(first(table.children).children).next
        @test rows[3] == first(first(table.children).children).next.next
        @test rows[4] == first(first(table.children).children).next.next.next
        @test rows[5] == first(first(table.children).children).next.next.next.next
    end
    @test tablesize(table) == (5, 7)

    for table in [
            @ast(Table([]) do; TableHeader(); TableBody(); end),
            @ast(Table([]) do; TableHeader(); end),
            @ast(Table([]) do; TableBody(); end),
            @ast(Table([])),
        ]
        @test length(collect(tablerows(table))) == 0
        @test tablesize(table) == (0, 0)
    end
end

using Test
using MarkdownAST: @ast, Document, Paragraph, Strong, Heading
using AbstractTrees

@testset "AbstractTrees" begin
    n = @ast Document() do
        Heading(1) do; "header"; end
        Paragraph() do; "..."; end
        Paragraph() do
            "Foo "
            Strong() do; "bar"; end
            " baz."
        end
    end

    # We don't implement getindex() for .children currently, so we just assert
    # here that AbstractTrees falls back to the correct default here
    @test AbstractTrees.ChildIndexing(n) == AbstractTrees.NonIndexedChildren()

    ns = collect(PreOrderDFS(n))
    @test length(ns) == 10
    @test ns[1].element == Document()
    @test ns[2].element == Heading(1)
    @test ns[3].element == MarkdownAST.Text("header")
    @test ns[4].element == Paragraph()
    @test ns[5].element == MarkdownAST.Text("...")
    @test ns[6].element == Paragraph()
    @test ns[7].element == MarkdownAST.Text("Foo ")
    @test ns[8].element == Strong()
    @test ns[9].element == MarkdownAST.Text("bar")
    @test ns[10].element == MarkdownAST.Text(" baz.")

    ns = collect(PostOrderDFS(n))
    @test length(ns) == 10
    @test ns[1].element == MarkdownAST.Text("header")
    @test ns[2].element == Heading(1)
    @test ns[3].element == MarkdownAST.Text("...")
    @test ns[4].element == Paragraph()
    @test ns[5].element == MarkdownAST.Text("Foo ")
    @test ns[6].element == MarkdownAST.Text("bar")
    @test ns[7].element == Strong()
    @test ns[8].element == MarkdownAST.Text(" baz.")
    @test ns[9].element == Paragraph()
    @test ns[10].element == Document()

    # ns = collect(StatelessBFS(n))
    # @test length(ns) == 10
    # @test ns[1].element == Document()
    # @test ns[2].element == Heading(1)
    # @test ns[3].element == Paragraph()
    # @test ns[4].element == Paragraph()
    # @test ns[5].element == MarkdownAST.Text("header")
    # @test ns[6].element == MarkdownAST.Text("...")
    # @test ns[7].element == MarkdownAST.Text("Foo ")
    # @test ns[8].element == Strong()
    # @test ns[9].element == MarkdownAST.Text(" baz.")
    # @test ns[10].element == MarkdownAST.Text("bar")

    ns = collect(Leaves(n))
    @test length(ns) == 5
    @test ns[1].element == MarkdownAST.Text("header")
    @test ns[2].element == MarkdownAST.Text("...")
    @test ns[3].element == MarkdownAST.Text("Foo ")
    @test ns[4].element == MarkdownAST.Text("bar")
    @test ns[5].element == MarkdownAST.Text(" baz.")
end

# Conversion methods from the standard library Markdown trees:
"""
    convert(::Type{Node}, md::Markdown.MD) -> Node
    convert(::Type{Node{M}}, md::Markdown.MD, meta=M) where M -> Node{M}

Converts a standard library Markdown AST into MarkdownAST representation.

Note that it is not possible to convert subtrees, as only `MD` objects can be converted.
The result will be a tree with [`Document`](@ref) as the root element.

When the type argument passed is `Node`, the resulting tree will be constructed of objects
of the default node type `Node{Nothing}`. However, it is also possible to convert into
MarkdownAST trees that have custom metadata field of type `M`, in which case the `M` type
must have a zero-argument constructor available, which will be called whenever a new `Node`
object gets constructed.

It is also possible to use a custom function to construct the `.meta` objects via the `meta
argument, which must be a callable object with a zero-argument method, and that then gets
called every time a new node is constructed.
"""
Base.convert(::Type{Node}, md::Markdown.MD) = convert(Node{Nothing}, md)
function Base.convert(::Type{Node{M}}, md::Markdown.MD, meta=M) where M
    _convert(NodeFn{M}(meta), Document(), _convert_block, md.content)
end

struct NodeFn{M}
    meta
end
(m::NodeFn{M})(element) where M = Node{M}(element, m.meta()::M)

function _convert(nodefn::NodeFn, c::AbstractElement, child_convert_fn, md_children)
    node = nodefn(c)
    for md_child in md_children
        childnode = child_convert_fn(nodefn, md_child)
        push!(node.children, childnode)
    end
    return node
end

_convert_block(nodefn::NodeFn, block::Markdown.Paragraph) = _convert(nodefn, Paragraph(), _convert_inline, block.content)
function _convert_block(nodefn::NodeFn, block::Markdown.Header{N}) where N
    # Empty headings have just an empty String as text, so this requires special treatment:
    c = Heading(N)
    if block.text isa AbstractString
        # TODO: If isempty(block.text), should we omit adding any children?
        headingnode = nodefn(c)
        push!(headingnode.children, nodefn(Text(block.text)))
        headingnode
    else
        _convert(nodefn, c, _convert_inline, block.text)
    end
end
_convert_block(nodefn::NodeFn, b::Markdown.BlockQuote) = _convert(nodefn, BlockQuote(), _convert_block, b.content)
_convert_block(nodefn::NodeFn, ::Markdown.HorizontalRule) = nodefn(ThematicBreak())
_convert_block(nodefn::NodeFn, b::Markdown.Code) = nodefn(CodeBlock(b.language, b.code))
@static if isdefined(Markdown, :HTMLBlock)
    _convert_block(nodefn::NodeFn, b::Markdown.HTMLBlock) = nodefn(HTMLBlock(join(b.content, '\n')))
end
# Non-Commonmark extensions
_convert_block(nodefn::NodeFn, b::Markdown.Admonition) = _convert(nodefn, Admonition(b.category, b.title), _convert_block, b.content)
_convert_block(nodefn::NodeFn, b::Markdown.LaTeX) = nodefn(DisplayMath(b.formula))
_convert_block(nodefn::NodeFn, b::Markdown.Footnote) = _convert(nodefn, FootnoteDefinition(b.id), _convert_block, b.text)

function _convert_block(nodefn::NodeFn, b::Markdown.List)
    list = nodefn(List(b.ordered == -1 ? :bullet : :ordered, !b.loose))
    # TODO: should we warn if tight != all(isequal(1), length.(b.items)) ?
    for item in b.items
        push!(list.children, _convert(nodefn, Item(), _convert_block, item))
    end
    return list
end

function _convert_block(nodefn::NodeFn, b::Markdown.Table)
    # If the Markdown table is somehow empty, we'll return an empty Table node
    isempty(b.rows) && return nodefn(Table([]))
    # We assume that the width of the table is the width of the widest row
    ncols = maximum(length(row) for row in b.rows)
    # Markdown uses :l / :r / :c for the table specs. We will also pad it with `:right`
    # values (standard library's default) if need be, or drop the last ones if there are too
    # many somehow.
    spec = _convert_column_spec.(b.align)
    if ncols > length(spec)
        rpad_array!(spec, ncols, :right)
    elseif ncols < length(spec)
        spec = spec[1:ncols]
    end
    # A MD table should always contain a header. We'll split it off from the rest.
    header_row, body_rows = Iterators.peel(b.rows)
    tablenode = nodefn(Table(spec))
    headernode = nodefn(TableHeader())
    push!(headernode.children, _convert_table_row(nodefn, header_row, spec=spec, isheader = true))
    push!(tablenode.children, headernode)
    # If it doesn't have any more rows, then we don't append a TableBody
    if length(b.rows) >= 2
        bodynode = nodefn(TableBody())
        for row in body_rows
            push!(bodynode.children, _convert_table_row(nodefn, row, spec=spec, isheader = false))
        end
        push!(tablenode.children, bodynode)
    end
    return tablenode
end
function _convert_table_row(nodefn::NodeFn, row; spec, isheader)
    ncols = length(spec)
    rownode = nodefn(TableRow())
    for (i, cell) in enumerate(row)
        c = TableCell(spec[i], isheader, i)
        cellnode = _convert(nodefn, c, _convert_inline, cell)
        push!(rownode.children, cellnode)
    end
    # If need be, we pad the row with empty TableCells, to make sure that each row has the
    # same number of cells
    if length(row) < ncols
        for i in (length(row)+1):ncols
            cell = TableCell(spec[i], isheader, i)
            push!(rownode.children, nodefn(cell))
        end
    end
    return rownode
end
_convert_column_spec(s :: Symbol) = (s === :r) ? :right :
    (s === :l) ? :left : (s === :c) ? :center : begin
        @warn "Invalid table spec in Markdown table: '$s'"
        :right
    end
function rpad_array!(xs::Vector{T}, n::Integer, e::T) where {T}
    n > 0
    length(xs) >= n && return xs
    i = n - length(xs)
    while i > 0
        push!(xs, e)
        i -= 1
    end
    return xs
end

# Inline nodes:
_convert_inline(nodefn::NodeFn, s::Markdown.Bold) = _convert(nodefn, Strong(), _convert_inline, s.text)
_convert_inline(nodefn::NodeFn, s::Markdown.Italic) = _convert(nodefn, Emph(), _convert_inline, s.text)
@static if isdefined(Markdown, :Strikethrough)
    _convert_inline(nodefn::NodeFn, s::Markdown.Strikethrough) = _convert(nodefn, Strikethrough(), _convert_inline, s.text)
end
function _convert_inline(nodefn::NodeFn, s::Markdown.Link)
    # The Base Markdown parser does not parse the title part, so we just default that to
    # an empty string.
    c = Link(s.url, "")
    if s.text isa AbstractString
        # Autolinks (the `<URL>` syntax) yield Link objects where .text is just a String
        linknode = nodefn(c)
        push!(linknode.children, nodefn(Text(s.text)))
        linknode
    else
        _convert(nodefn, c, _convert_inline, s.text)
    end
end
function _convert_inline(nodefn::NodeFn, s::Markdown.Code)
    # TODO: proper error, or perhaps a warning
    @assert isempty(s.language) "Inline code span must not have language attribute"
    nodefn(Code(s.code))
end

# The standard library parser does not handle the title, so we just default that to an empty
# string. Also, the "alt" part inside the [] bracket is parsed as a simple string, rather
# than as proper Markdown. So we just return a corresponding Text() node.
_convert_inline(nodefn::NodeFn, s::Markdown.Image) = @ast Image(s.url, "") do
    s.alt # TODO: if isempty(s.alt), should be just omit adding children here?
end
_convert_inline(nodefn::NodeFn, ::Markdown.LineBreak) = nodefn(LineBreak())
@static if isdefined(Markdown, :HTMLInline)
    _convert_inline(nodefn::NodeFn, s::Markdown.HTMLInline) = nodefn(HTMLInline(s.content))
end
# Non-Commonmark extensions
_convert_inline(nodefn::NodeFn, s::Markdown.LaTeX) = nodefn(InlineMath(s.formula))
function _convert_inline(nodefn::NodeFn, s::Markdown.Footnote)
    @assert s.text === nothing # footnote references should not have any content, TODO: error
    nodefn(FootnoteLink(s.id))
end
_convert_inline(nodefn::NodeFn, s::AbstractString) = nodefn(Text(s))

# Fallback methods for non-Markdown types. If we find such nodes in the tree, we assume that
# they correspond to the interpolation of Julia values.
_convert_inline(nodefn::NodeFn, x) = nodefn(JuliaValue(nothing, x))
# JuliaValue is an inline node, so in a block context we surround it with a Paragraph.
# Incidentally, this would also capture any inline nodes that somehow have ended up in a
# block context.
function _convert_block(nodefn::NodeFn, x)
    p = nodefn(Paragraph())
    push!(p.children, _convert_inline(nodefn::NodeFn, x))
    return p
end

# This file contains the implementation for the Node type, which is a simple
# linked list based implementation of a Markdown AST tree.

"""
    mutable struct Node{M}

Implements a linked list type representation of a Markdown abstract syntax tree, where each
node contains pointers to the children and parent nodes, to make it possible to easily
traverse the whole tree in any direction. Each node also contains an "element", which is an
instance of some [`AbstractElement`](@ref MarkdownAST.AbstractElement) subtype, and can be
accessed via the `.element` property. The element object contains the semantic information
about the node (e.g. wheter it is a list or a paragraph).

Optionally, each node can also store additional meta information, which will be an object of
type `M` (see also the `.meta` property). By default, the node does not contain any extra
meta information and `M = Nothing`.

# Constructors

```julia
Node(element :: AbstractElement)
```

Constructs a simple standalone node (not part of any tree) without any additional metadata
(`M = Nothing`) containing the Markdown AST element `c`.

```julia
Node{M}(element :: AbstractElement, meta :: M)
```

Constructs a simple standalone node (not part of any tree) with the meta information `meta`,
containing the Markdown AST element `c`.

# Extended help

There are various properties that can be used to access the details of a node. Many of them
can not be set directly though, as that could lead to an inconsistent tree. Similarly, the
underlying fields of the struct should not be accessed directly.

- `.meta :: M`: can be used to access or set the extra meta information of the node.
- `.element :: T where {T <: AbstractElement}`: can be used to access or set the _element_
  corresponding to the node
- `.next :: Union{Node{M},Nothing}`: access the next child node after this one, with the
  value set to `nothing` if there is no next child
- `.previous :: Union{Node{M},Nothing}`: access the previous child node before this one,
  with the value set to `nothing` if there is no such node
- `.parent :: Union{Node{M},Nothing}`: access the parent node of this node, with the value
  set to `nothing` if the node does not have a parent
- `.children`: an iterable object of type [`NodeChildren`](@ref) that can be used to access
  and modify the child nodes of this node

The `.children` field is implemented with a wrapper type that implemements the iteration
protocol. However, the exact type information etc. is an implementation detail, and one
should only rely on the following documented APIs:

- The following methods are implemented for `.children`:
  [`length`](@ref Base.length(children::NodeChildren)),
  [`eltype`](@ref Base.eltype(::Type{NodeChildren{T}}) where T),
  [`first`](@ref Base.first(::NodeChildren)),
  [`last`](@ref Base.last(::NodeChildren)),
  [`isempty`](@ref Base.isempty(::NodeChildren)),
  [`empty!`](@ref Base.empty!(::NodeChildren))
- Appending or prepending new children to a parent node can be done with the
  [`push!`](@ref Base.push!(children::NodeChildren{T}, child::T) where {T <: Node}),
  [`pushfirst!`](@ref Base.pushfirst!(children::NodeChildren{T}, child::T) where {T <: Node}),
  [`append!`](@ref Base.append!(::NodeChildren{T}, ::Any) where T),
  and [`prepend!`](@ref Base.prepend!(::NodeChildren{T}, ::Any) where T)
  methods

Other ways to work with child nodes that do not directly reference `.children` are:

- To add new children between others, the [`insert_after!`](@ref), [`insert_before!`](@ref)
  functions can be used to insert new children relative to a reference child node.
- To remove a child from a node, the [`unlink!`](@ref) function can be used on the
  corresponding child node.

In addition, there are other functions and methods that can be used to work with nodes and
trees:

* Querying information about the node: [`haschildren`](@ref)
* Removing a node from a tree: [`unlink!`](@ref)
* Two trees can be compared with the
  [`==` operator](@ref Base.:(==)(x::Node{T}, y::Node{T}) where T)
* Mutating a tree: [`replace!`](@ref) and [`replace`](@ref)
"""
mutable struct Node{M}
    t :: AbstractElement
    parent :: Union{Node{M}, Nothing}
    first_child :: Union{Node{M}, Nothing}
    last_child :: Union{Node{M}, Nothing}
    prv :: Union{Node{M}, Nothing}
    nxt :: Union{Node{M}, Nothing}
    meta :: M

    function Node{M}(element::AbstractElement, meta::M) where M
        new{M}(element, nothing, nothing, nothing, nothing, nothing, meta)
    end
end
Node(element::AbstractElement) = Node{Nothing}(element, nothing)

Base.propertynames(::Node) = (
    :element, :children, :next, :previous, :parent, :meta,
)

function Base.getproperty(node::Node{T}, name::Symbol) where T
    if name === :element
        getfield(node, :t)
    elseif name === :children
        NodeChildren(node)
    elseif name === :next
        getfield(node, :nxt)
    elseif name === :previous
        getfield(node, :prv)
    elseif name === :parent
        getfield(node, :parent)
    elseif name === :meta
        getfield(node, :meta)
    else
        # TODO: error("type Node does not have property $(name)")
        getfield(node, name)
    end
end

function Base.setproperty!(node::Node, name::Symbol, x)
    if name === :element
        setfield!(node, :t, x)
    elseif name === :meta
        setfield!(node, :meta, x)
    elseif name in propertynames(node)
        # TODO: error("Unable to set property $(name) for Node")
        setfield!(node, name, x)
    else
        # TODO: error("type Node does not have property $(name)")
        setfield!(node, name, x)
    end
end

function Base.show(io::IO, node::Node{M}) where M
    print(io, "@ast ")
    M === Nothing || print(io, "$M ")
    _showast(io, node)
end
function _showast(io::IO, node::Node; indent = 0)
    prefix = ' '^(2*indent)
    print(io, prefix, node.element)
    if haschildren(node)
        println(io, " do")
        for child in node.children
            _showast(io, child; indent = indent + 1)
        end
        print(io, prefix, "end")
    end
    println(io)
end

"""
    haschildren(node::Node) -> Bool

Returns `true` if `node` has any children nodes and `false` otherwise.
"""
haschildren(node::Node) = !isnothing(getfield(node, :first_child))

"""
    unlink!(node::Node) -> Node

Isolates and removes the node from the tree by removing all of its links to its neighboring
nodes. Returns the updated node, which is now a single, isolate root node.
"""
function unlink!(node::Node)
    # Remove the node from its current tree, turning into a root node.
    # It retains all of its children, which now only exists in this new tree.

    # If there is a previous child on this level, then we just have to make sure it
    # points to the next one
    # However, if this is the first child, then we need to update the parent
    # node (if there is one; there isn't if this is a root node).
    if !isnothing(node.prv)
        node.prv.nxt = node.nxt
    elseif !isnothing(node.parent)
        node.parent.first_child = node.nxt
    end

    # Same logic as above, but checking if this is the last child or not.
    if !isnothing(node.nxt)
        node.nxt.prv = node.prv
    elseif !isnothing(node.parent)
        node.parent.last_child = node.prv
    end

    # Now that the siblings are parents are updated, the references in this node
    # can be erased.
    node.nxt, node.prv, node.parent = nothing, nothing, nothing

    # Return the updated (now root) node.
    return node
end

# The precise types etc of the iterator of the child nodes is considered to be an
# implementation detail. It should only be constructed by calling the relevant public APIs.
# In practice, the argument to ChildrenIterator is simply the node where the iterator starts
"""
    struct NodeChildren

The type of the the `.children` property of a [`Node`](@ref) which acts as an iterator over
the children of a node. This type is mostly considered to be an implementation detail, and
only has the following publicly defined APIs:

* The name of the type `NodeChildren`, so that it could be dispatched on.
* The `.parent :: Node` field that allows the user to access the parent node of the children.
"""
struct NodeChildren{T <: Node}
    parent :: T
    NodeChildren(parent::T) where {T <: Node} = new{T}(parent)
end
function Base.iterate(children::NodeChildren{T}, state::Union{T,Nothing} = nothing) where {T <: Node}
    nextnode = isnothing(state) ? getfield(children.parent, :first_child) : state.next
    isnothing(nextnode) ? nothing : (nextnode, nextnode)
end

"""
    eltype(node.children::NodeChildren) = Node{M}

Returns the exact `Node` type of the tree, corresponding to the type of the elements of the
`.children` iterator.
"""
Base.eltype(::Type{NodeChildren{T}}) where T = T

"""
    length(node.children::NodeChildren) -> Int

Returns the number of children of `node :: Node`.

As the children are stored as a linked list, this method has O(n) complexity. As such, to
check there are any children at all, it is generally preferable to use
[`isempty`](@ref Base.isempty(::NodeChildren)).
"""
function Base.length(children::NodeChildren)
    len = 0
    node = getfield(children.parent, :first_child)
    while !isnothing(node)
        len += 1
        node = node.next
    end
    return len
end

"""
    first(node.children::NodeChildren) -> Node

Returns the first child of the `node :: Node`, or throws an error if the node has no
children.
"""
function Base.first(children::NodeChildren{T}) where T
    first_child = getfield(children.parent, :first_child)
    # Error type consistent with first(""):
    isnothing(first_child) && throw(ArgumentError("collection must be non-empty"))
    return first_child :: T
end

"""
    last(node.children::NodeChildren) -> Node

Returns the last child of the `node :: Node`, or throws an error if the node has no
children.
"""
function Base.last(children::NodeChildren{T}) where T
    last_child = getfield(children.parent, :last_child)
    # Error type consistent with first(""):
    isnothing(last_child) && throw(ArgumentError("collection must be non-empty"))
    return last_child :: T
end

"""
    isemtpy(node.children::NodeChildren) -> Bool

Can be called on the `.children` field of a `node :: Node` to determine whether or not the
node has any child nodes.
"""
Base.isempty(children::NodeChildren) = !haschildren(children.parent)


"""
    empty!(node.children::NodeChildren) -> NodeChildren

Removes all the `children` of a `node`.
"""
function Base.empty!(children::NodeChildren)
    while haschildren(children.parent)
        unlink!(first(children))
    end
    return children
end


"""
    Base.push!(node.children::NodeChildren, child::Node) -> NodeChildren

Adds `child` as the last child node of `node :: Node`. If `child` is part of another tree,
then it is unlinked from that tree first (see [`unlink!`](@ref)). Returns the iterator over
children.
"""
function Base.push!(children::NodeChildren{T}, child::T) where {T <: Node}
    node = children.parent
    assert_can_contain(node, child)
    # append_child
    # The child node is unlinked first
    unlink!(child)
    child.parent = node
    # If there are existing children, we need to update the current last child.
    # Otherwise, we just make sure that the first and last pointers point to this
    # child.
    if !isnothing(node.last_child)
        node.last_child.nxt = child
        child.prv = node.last_child
        node.last_child = child
    else
        node.first_child = child
        node.last_child = child
    end
    # Return the updated parent node
    return children
end
# Helful error message if the user does push!(node, child)
function Base.push!(::Node, ::Any)
    throw(UnimplementedMethodError(
        "push!(node::Node, ...)",
        "If you want to add new children to a node, use push!(node.children, ...) instead."
    ))
end

"""
    Base.pushfirst!(node.children::NodeChildren, child::Node) -> NodeChildren

Adds `child` as the first child node of `node :: Node`. If `child` is part of another tree,
then it is unlinked from that tree first (see [`unlink!`](@ref)). Returns the iterator over
children.
"""
function Base.pushfirst!(children::NodeChildren{T}, child::T) where T
    node = children.parent
    assert_can_contain(node, child)
    # prepend_child
    # The child node is unlinked first
    unlink!(child)
    child.parent = node
    # If there are existing children, we need to update the current first child.
    # Otherwise, we just make sure that the first and last pointers point to this
    # child.
    if !isnothing(node.first_child)
        node.first_child.prv = child
        child.nxt = node.first_child
        node.first_child = child
    else
        node.first_child = child
        node.last_child = child
    end
    # Return the updated parent node
    return children
end
# Helful error message if the user does pushfirst!(node, child)
function Base.pushfirst!(::Node, ::Any)
    throw(UnimplementedMethodError(
        "pushfirst!(node::Node, ...)",
        "If you want to add new children to a node, use pushfirst!(node.children, ...) instead."
    ))
end

"""
    insert_after!(node::Node, sibling::Node) -> Node

Inserts a new child node `sibling` as the next child after `node`. `node` must not be a root
node. If `sibling` is part of another tree, then it is unlinked from that tree first (see
[`unlink!`](@ref)). Returns the original reference node.
"""
function insert_after!(node::Node, sibling::Node)
    # Adds the sibling after this node:
    isrootnode(node) && throw(ArgumentError("the reference node must not be a root node"))
    assert_can_contain(node.parent, sibling)
    # The sibling node is unlinked first:
    unlink!(sibling)
    # If there is a node after `node`, we point sibling to it:
    sibling.nxt = node.nxt
    if !isnothing(sibling.nxt)
        sibling.nxt.prv = sibling
    end
    # Create link between node and sibling
    sibling.prv = node
    node.nxt = sibling
    # The current node's parent is also the sibling's parent.
    sibling.parent = node.parent
    # If this node is the last child, we need to update the parent too.
    if isnothing(sibling.nxt)
        sibling.parent.last_child = sibling
    end
    # Return the original reference node
    return node
end

"""
    insert_before!(node::Node, sibling::Node) -> Node

Inserts a new child node `sibling` as the child right before `node`. `node` must not be a
root node. If `sibling` is part of another tree, then it is unlinked from that tree first
(see [`unlink!`](@ref)). Returns the original reference node.
"""
function insert_before!(node::T, sibling::T) where {T <: Node}
    # Fallback method for insert_before!
    isrootnode(node) && throw(ArgumentError("the reference node must not be a root node"))
    assert_can_contain(node.parent, sibling)
    # If this node is the first node, then we can prepend the sibling as a child
    # to the parent node. Otherwise, we just insert it after the previous node.
    if isnothing(node.previous)
        pushfirst!(node.parent, sibling)
    else
        insert_after!(node.previous, sibling)
    end
    return node
end

"""
    append!(node.children::NodeChildren, children) -> NodeChildren

Adds all the elements of the iterable `children` to the end of the list of children of `node`.
If any of `children` are part of another tree, then they are unlinked from that tree first
(see [`unlink!`](@ref)). Returns the iterator over children.

!!! warning "Error during an append"

    The operation is not atomic, and an error during an `append!` (e.g. due to an element of
    the wrong type in `children`) can result in a partial append of the new children, similar
    to how `append!` behaves with arrays
    (see [JuliaLang/julia#15868](https://github.com/JuliaLang/julia/issues/15868)).
"""
function Base.append!(nodechildren::NodeChildren{T}, children) where T
    for child in collect(children)
        isa(child, T) || throw(ArgumentError("invalid element type ($(typeof(child))) in children, expected $T"))
        push!(nodechildren, child)
    end
    return nodechildren
end

"""
    prepend!(node.children::NodeChildren, children) -> NodeChildren

Adds all the elements of the iterable `children` to the beginning of the list of children of `node`.
If any of `children` are part of another tree, then they are unlinked from that tree first
(see [`unlink!`](@ref)). Returns the iterator over children.

!!! warning "Error during a prepend"

    The operation is not atomic, and an error during a `prepend!` (e.g. due to an element of
    the wrong type in `children`) can result in a partial prepend of the new children, similar
    to how `append!` behaves with arrays
    (see [JuliaLang/julia#15868](https://github.com/JuliaLang/julia/issues/15868)).
"""
function Base.prepend!(nodechildren::NodeChildren{T}, children) where T
    for child in Iterators.reverse(collect(children))
        isa(child, T) || throw(ArgumentError("invalid element type ($(typeof(child))) in children, expected $T"))
        pushfirst!(nodechildren, child)
    end
    return nodechildren
end

"""
    replace(f::Function, root::Node) -> Node

Creates a copy of the tree where all child nodes of `root` are recursively
(post-order depth-first) replaced by the result of `f(child)`.

The function `f(child::Node)` must return either a new [`Node`](@ref) to
replace `child` or a Vector of nodes that will be inserted as siblings,
replacing `child`.

Note that `replace` does not allow the construction of invalid trees, and
element replacements that require invalid parent-child relationships (e.g., a
block element as a child to an element expecting inlines) will throw an error.

# Example

The following snippet removes links from the given AST. That is, it replaces
[`Link`](@ref) nodes with their link text (which may contain nested inline
markdown elements):

```julia
new_mdast = replace(mdast) do node
    if node.element isa MarkdownAST.Link
        return [MarkdownAST.copy_tree(child) for child in node.children]
    else
        return node
    end
end
```
"""
function Base.replace(f::Function, root::Node{M}) where {M}
    new_root = Node{M}(root.element, deepcopy(root.meta))
    for child in root.children
        replaced_child = replace(f, child)
        transformed = f(replaced_child)
        if transformed isa Node
            push!(new_root.children, transformed)
        elseif transformed isa Vector
            append!(new_root.children, transformed)
        else
            throw(ArgumentError("Function `f` in `replace(f, root::MarkdownAST.Node)` must return either a Node or a Vector of nodes, not $(repr(typeof(transformed)))"))
        end
    end
    return new_root
end


"""
    replace!(f::Function, root::Node) -> Node

Acts like [`replace(f, root)`](@ref replace), but modifies `root` in-place.
"""
function Base.replace!(f::Function, root::Node)
    new_root = replace(f, root)
    empty!(root.children)
    append!(root.children, new_root.children)
    return root
end


# Check if this is a root node. Next and previous should also be nothing, but this is not
# enforced. This function is currently not part of the public API.
isrootnode(node::Node) = isnothing(node.parent)

"""
    ==(x::Node, y::Node) -> Bool

Determines if two trees are equal by recursively walking through the whole tree (if need be)
and comparing each node. Parent nodes are ignored when comparing for equality (so that it
would be possible to compare subtrees). If the metadata type does not match, the two trees
are not considered equal.
"""
function Base.:(==)(x::Node{T}, y::Node{T}) where T
    x.element == y.element || return false
    x.meta == y.meta || return false
    # Finally we compare all the children (which, of course, recursively compare their
    # children). In principle, the first check could be length(x.children) == length(y.children),
    # but length() here is O(n). So we pairwise iterate through the children, comparing each
    # pair, and bailing right away if something doesn't match. However, a naive zip use
    # doesn't handle the case where the number of children is different. Hence we lazily
    # append a nothing to each iterator.
    x_children_padded = Iterators.flatten((x.children, (nothing,)))
    y_children_padded = Iterators.flatten((y.children, (nothing,)))
    for (xc, yc) in zip(x_children_padded, y_children_padded)
        xc == yc || return false
    end
    return true
end

function assert_can_contain(parent::T, child::T) where {T <: Node}
    can_contain(parent.element, child.element) && return nothing
    throw(InvalidChildException(parent.element, child.element))
end

# While these are not hard requirements, in general:
#
# - If a container does not contain any metadata, it should be implemented as a
#   simple non-mutable singleton (struct Foo end).
# - If a container contains some metadata (e.g. a link URL), then it should be
#   implemented as a mutable struct, so that it would be possible to manipulate
#   the container contents.

"""
    abstract type AbstractElement

A supertype of all Markdown AST element types.

User-defined elements must not directly inherit this type, but either
[`AbstractBlock`](@ref) or [`AbstractInline`](@ref) instead.

# Interface

* By default, each element is assumed to be a leaf element that can not contain other
  elements as children. An [`iscontainer`](@ref) method can be defined to override this.

* [`can_contain`](@ref) can be overridden to constrain what elements can be the direct
  children of another node. By default, inline container elements can contain any inline
  element and block container elements can contain any block element.

* Elements that are implemented as `mutable struct`s should probably implement the equality
  operator (`==`), to make sure that two different instances that are semantically the same
  would be considered equal.
"""
abstract type AbstractElement end

"""
    abstract type AbstractBlock <: AbstractElement

Supertype of all Markdown AST block types.
"""
abstract type AbstractBlock <: AbstractElement end

"""
    abstract type AbstractInline <: AbstractElement

Supertype of all Markdown AST inline types.
"""
abstract type AbstractInline <: AbstractElement end

"""
    isblock(element::AbstractElement) -> Bool

Determines if `element` is a block element (a subtype of [`AbstractBlock`](@ref)).
"""
function isblock end
isblock(::AbstractBlock) = true
isblock(::AbstractInline) = false

"""
    isinline(element::AbstractElement) -> Bool

Determines if `element` is an inline element (a subtype of [`AbstractInline`](@ref)).
"""
function isinline end
isinline(::AbstractBlock) = false
isinline(::AbstractInline) = true

"""
    iscontainer(::T) where {T <: AbstractElement} -> Bool

Determines if the particular Markdown element is a container, meaning that is can contain
child nodes. Adding child nodes to non-container (leaf) nodes is prohibited.

By default, each user-defined element is assumed to be a leaf node, and each container node
should override this method.
"""
function iscontainer end
iscontainer(::AbstractElement) = false

"""
    can_contain(parent::AbstractElement, child::AbstractElement) -> Bool

Determines if the `child` element can be a direct child of the `parent` element.

This is used to constrain the types of valid children for some elements, such as for the
elements that are only allowed to have inline child elements or to make sure that
[`List`s](@ref MarkdownAST.List) only contain [`Item`s](@ref MarkdownAST.Item).

If the `parent` element is a leaf node (`iscontainer(parent) === false`)

# Extended help

When extending `can_contain` for custom abstract classes Markdown elements, similar to the
[`AbstractBlock`](@ref) or [`AbstractInline`](@ref) elements classes, the second argument to
[`can_contain`](@ref) should always be constrained exactly to `::AbstractElement`, in order
to avoid method ambiguities. I.e. for some abstract type `AbstractT  <: AbstractElement`,
the method should be defined as

```julia
can_contain(parent::AbstractT, child::AbstractElement) = ...
```

For concrete parent types `T`, where the first argument is constrained as `parent::T` it
should then be fine to take advantage of multiple dispatch when implementing
[`can_contain`](@ref).
"""
function can_contain end
# These methods ensure that, by default, container blocks/inlines are allowed to contain
# any blocks/inlines (respectively). However, we need the isa() calls here because the
# AbstractBlock and AbstractInline are abstract types.
can_contain(parent::AbstractBlock, child::AbstractElement) = iscontainer(parent) && isa(child, AbstractBlock)
can_contain(parent::AbstractInline, child::AbstractElement) = iscontainer(parent) && isa(child, AbstractInline)
# The following method will be called if one mixes blocks and inlines (unless specifically
# overridden), and also functions as the ultimate fallback for can_contain.
can_contain(parent::AbstractElement, child::AbstractElement) = false

"""
    struct Document <: AbstractBlock

Singleton top-level element of a Markdown document.
"""
struct Document <: AbstractBlock end
iscontainer(::Document) = true

# CommonMark block containers:

# TODO: The CommonMark.jl list contains additional metadata, via the `ListData` object,
# which is also passed on to the children.
"""
    mutable struct List <: AbstractBlock

Represents a Markdown list.
The children of a `List` should only be [`Item`s](@ref MarkdownAST.Item), representing
individual list items.

# Fields

* `.type :: Symbol`: determines if this is an ordered (`:ordered`) or an unordered
  (`:bullet`) list.
* `.tight :: Bool`: determines if the list should be rendered tight or loose.

# Constructors

```julia
List(type :: Symbol, tight :: Bool)
````
"""
mutable struct List <: AbstractBlock
    type :: Symbol # TODO: change to enum?
    tight :: Bool

    function List(type::Symbol, tight::Bool)
        type === :bullet || type === :ordered || error("type must be :bullet or :ordered")
        new(type, tight)
    end
end
iscontainer(::List) = true
Base.:(==)(x::List, y::List) = (x.type == y.type) && (x.tight == y.tight)

"""
    struct Item <: AbstractBlock

Singleton container representing the items of a [`List`](@ref).
"""
struct Item <: AbstractBlock end
iscontainer(::Item) = true
# List can only contain Item, and Item can only be contained in a List.
can_contain(::List, ::AbstractElement) = false
can_contain(::List, ::Item) = true

"""
    struct ThematicBreak <: AbstractBlock

A singleton leaf element representing a thematic break (often rendered as a horizontal
rule).
"""
struct ThematicBreak <: AbstractBlock end

"""
    struct BlockQuote <: AbstractBlock

A singleton container element representing a block quote. It must contain other block
elements as children.
"""
struct BlockQuote <: AbstractBlock end
iscontainer(::BlockQuote) = true

"""
    mutable struct Heading <: AbstractBlock

Represents a heading of a specific level. Can only contain inline elements as children.

# Fields

* `.level :: Int`: the level of the heading, must be between `1` and `6`.

# Constructors

```julia
Heading(level :: Integer)
```
"""
mutable struct Heading <: AbstractBlock
    level :: Int
    function Heading(level :: Integer)
        1 <= level <= 6 || error("level must be 1 <= level <= 6")
        new(level)
    end
end
iscontainer(::Heading) = true
# Can only contain inline elements and not block elements:
can_contain(::Heading, ::AbstractInline) = true
can_contain(::Heading, ::AbstractBlock) = false
Base.:(==)(x::Heading, y::Heading) = (x.level == y.level)

"""
    struct Paragraph <: AbstractBlock

Singleton container representing a paragraph, containing only inline nodes.
"""
struct Paragraph <: AbstractBlock end
iscontainer(::Paragraph) = true
# Can only contain inline elements and not block elements:
can_contain(::Paragraph, ::AbstractInline) = true
can_contain(::Paragraph, ::AbstractBlock) = false

"""
    mutable struct HTMLBlock <: AbstractBlock

A leaf block representing raw HTML.
"""
mutable struct HTMLBlock <: AbstractBlock
    html :: String
end
Base.:(==)(x::HTMLBlock, y::HTMLBlock) = (x.html == y.html)

"""
    mutable struct CodeBlock <: AbstractBlock

A leaf block representing a code block.

# Fields

* `.info :: String`: code block info string (e.g. the programming language label)
* `.code :: String`: code content of the block
"""
mutable struct CodeBlock <: AbstractBlock
    info :: String
    code :: String
    # TODO: `info` shouldn't contain any backtick characters. Restrict in constructor?
end
Base.:(==)(x::CodeBlock, y::CodeBlock) = (x.info == y.info) && (x.code == y.code)

# CommonMark inline containers:

"""
    mutable struct Link <: AbstractInline

Inline element representing a link. Can contain other inline nodes, but should not contain
other [`Link`s](@ref MarkdownAST.Link).

# Fields

* `.destination :: String`: destination URL
* `.title :: String`: title attribute of the link

# Constructors

```julia
Link(destination::AbstractString, title::AbstractString)
```
"""
mutable struct Link <: AbstractInline
    destination :: String
    title :: String
end
iscontainer(::Link) = true
Base.:(==)(x::Link, y::Link) = (x.destination == y.destination) && (x.title == y.title)

"""
    mutable struct Image <: AbstractInline

Inline element representing a link to an image. Can contain other inline nodes that will
represent the image description.

# Fields

* `.destination :: String`: destination URL
* `.title :: String`: title attribute of the link

# Constructors

```julia
Image(destination::AbstractString, title::AbstractString)
```
"""
mutable struct Image <: AbstractInline
    destination :: String
    title :: String
end
iscontainer(::Image) = true
Base.:(==)(x::Image, y::Image) = (x.destination == y.destination) && (x.title == y.title)

"""
    mutable struct HTMLInline <: AbstractInline

Inline leaf element representing raw inline HTML.

# Fields

* `.html :: String`: inline raw HTML

# Constructors

```julia
HTMLInline(html::AbstractString)
```
"""
mutable struct HTMLInline <: AbstractInline
    html :: String
end
Base.:(==)(x::HTMLInline, y::HTMLInline) = (x.html == y.html)

"""
    struct Emph <: AbstractInline

Inline singleton element for emphasis (e.g. italic) styling.
"""
struct Emph <: AbstractInline end
iscontainer(::Emph) = true

"""
    struct Strong <: AbstractInline

Inline singleton element for strong (e.g. bold) styling.
"""
struct Strong <: AbstractInline end
iscontainer(::Strong) = true

"""
    struct Strikethrough <: AbstractInline

Inline singleton element for strikethrough styling.
"""
struct Strikethrough <: AbstractInline end
iscontainer(::Strikethrough) = true

"""
    mutable struct Code <: AbstractInline

Inline element representing an inline code span.

# Fields

* `.code :: String`: raw code

# Constructors

```julia
Code(code::AbstractString)
```
"""
mutable struct Code <: AbstractInline
    code :: String
end
Base.:(==)(x::Code, y::Code) = (x.code == y.code)

"""
    mutable struct Text <: AbstractInline

Inline leaf element representing a simply a span of text.
"""
mutable struct Text <: AbstractInline
    text :: String
end
Base.:(==)(x::Text, y::Text) = (x.text == y.text)

# Julia Markdown extensions:

"""
    mutable struct Admonition <: AbstractBlock

A container block representing an admonition. Can contain other block elements as children.

# Fields

* `.category :: String`: admonition category
* `.title :: String`: admonition title

# Constructors
```julia
Admonition(category :: AbstractString, title :: AbstractString)
```
"""
mutable struct Admonition <: AbstractBlock
    # TODO: constraints on the category string?
    category :: String
    title :: String
end
iscontainer(::Admonition) = true
Base.:(==)(x::Admonition, y::Admonition) = (x.category == y.category) && (x.title == y.title)

"""
    mutable struct DisplayMath <: AbstractBlock

Leaf block representing a mathematical display equation.

# Fields

* `.math :: String`: TeX code of the display equation

# Constructors

```julia
DisplayMath(math :: AbstractString)
```
"""
mutable struct DisplayMath <: AbstractBlock
    math :: String
end
Base.:(==)(x::DisplayMath, y::DisplayMath) = (x.math == y.math)

"""
    mutable struct InlineMath <: AbstractInline

Leaf inline element representing an inline mathematical expression.

# Fields

* `.math :: String`: TeX code for the inline equation

# Constructors

```julia
InlineMath(math::String)
```
"""
mutable struct InlineMath <: AbstractInline
    math :: String
end
Base.:(==)(x::InlineMath, y::InlineMath) = (x.math == y.math)

# TODO: In CommonMark, these were actually immutable..?
# TODO: Does this have to contain block elements, or can it also contain inline elements
#       directly?
"""
    mutable struct FootnoteDefinition <: AbstractBlock

Container block representing the definition of a footnote, containing the definitions of the
footnote as children.

# Fields

* `.id :: String`: label of the footnote

# Constructors

```julia
FootnoteDefinition(id :: AbstractString)
```
"""
mutable struct FootnoteDefinition <: AbstractBlock
    id :: String
end
iscontainer(::FootnoteDefinition) = true
Base.:(==)(x::FootnoteDefinition, y::FootnoteDefinition) = (x.id == y.id)

"""
    mutable struct FootnoteLink <: AbstractInline

Inline leaf element representing a link to a footnote.

# Fields

* `.id :: String`: label of the footnote

# Constructors

```julia
FootnoteLink(id :: AbstractString)
```
"""
mutable struct FootnoteLink <: AbstractInline
    id :: String
    # TODO: Also had this field in CommonMark:
    #rule::FootnoteRule
end
Base.:(==)(x::FootnoteLink, y::FootnoteLink) = (x.id == y.id)

# Markdown tables:
abstract type TableComponent <: AbstractBlock end
iscontainer(::TableComponent) = true

"""
    mutable struct Table <: TableComponent

Container block representing a table, an extension of the CommonMark spec, and should be
interpreted as a rectangular grid of cells with a fixed number of rows and columns.

* A [`Table`](@ref) node can only contain either [`TableHeader`](@ref) or
  [`TableBody`](@ref) nodes as children.
* [`TableHeader`](@ref) and [`TableBody`](@ref) can only contain [`TableRow`](@ref)s
  as children. A [`TableHeader`](@ref) should contain only a single [`TableRow`](@ref), and
  any additional ones should be ignored.
* Each [`TableRow`](@ref) contains only [`TableCell`](@ref)s as children. The row with the
  largest number of cells determines the width (number of columns) of the table.

Since we can not constrain e.g. the number of children or in what order child nodes can
appear in a Markdown tree, it is possible to construct tables that can be difficult to
interpret. The following rules should be followed when interpreting tables:

* The decendants of a [`Table`](@ref) node should be exactly be a single
  [`TableHeader`](@ref) followed by a [`TableBody`](@ref).
  - If the first child is a [`TableBody`](@ref), the header row is assumed to be a list of
    empty cells.
  - The rows from any nodes following the first [`TableBody`](@ref) are interpreted as
    additional table body rows, even if they are contained in a [`TableHeader`](@ref).
  - A [`Table`](@ref) with no children is interpreted as a table with a single empty header
    cell.
* A [`TableHeader`](@ref) that is the first child of a [`Table`](@ref) should only contain
  one [`TableRow`](@ref).
  - If a [`TableHeader`](@ref) that is the first child of a [`Table`](@ref) contains
    additional rows, the additional rows are interpreted to be body rows.
  - If a [`TableHeader`](@ref) that is the first child of a [`Table`](@ref) is empty, it is
    assumed to represent a header row with empty cells.
* Each [`TableRow`](@ref) of a table should contain the same number of [`TableCell`](@ref).
  - Any row that has fewer cells than the longest row should be interpreted as if it is
    padded with additional empty cells.
"""
mutable struct Table <: TableComponent
    spec :: Vector{Symbol}

    function Table(spec)
        for (ncol, s) in enumerate(spec)
            s in [:left, :right, :center] && continue
            error("Invalid table specifier '$s' for column $ncol")
        end
        new(collect(spec))
    end
end
Base.:(==)(x::Table, y::Table) = (x.spec == y.spec)
can_contain(::Table, e::AbstractElement) = isa(e, TableHeader) || isa(e, TableBody)

"""
    struct TableHeader <: TableComponent

Represents the header portion of a Markdown table and should only occur as the first child
of a [`Table`](@ref) node and should only contain a single [`TableRow`](@ref) as a child.
See [`Table`](@ref) for information on how to handle other circumstances.

It can only contain [`TableRow`](@ref) elements.
"""
struct TableHeader <: TableComponent end
can_contain(::TableHeader, e::AbstractElement) = isa(e, TableRow)

"""
    struct TableBody <: TableComponent

Represents the body of a Markdown table and should only occur as the second child of a
[`Table`](@ref) node. See [`Table`](@ref) for information on how to handle other
circumstances.

It can only contain [`TableRow`](@ref) elements.
"""
struct TableBody <: TableComponent end
can_contain(::TableBody, e::AbstractElement) = isa(e, TableRow)

"""
    struct TableRow <: TableComponent

Represents a row of a Markdown table. Can only contain [`TableCell`](@ref)s as children.
"""
struct TableRow <: TableComponent end
can_contain(::TableRow, e::AbstractElement) = isa(e, TableCell)

"""
    mutable struct TableCell <: TableComponent

Represents a single cell in a Markdown table. Can contain inline nodes.

* `align :: Symbol`: declares the alignment of a cell (can be `:left`, `:right`, or
  `:center`), and should match the `.spec` field of the ancestor [`Table`](@ref)
* `header :: Bool`: `true` if the cell is part of a header row, and should only be true if
  the cell belongs to a row that is the first
* `column :: Int`: the column index of the cell, which should match its position in the
  Markdown tree

It is possible that the fields of [`TableCell`](@ref) are inconsistent with the real
structure of the Markdown tree, in which case the structure or the `.spec` field should take
precedence when interpreting the elements.
"""
mutable struct TableCell <: TableComponent
    align :: Symbol
    header :: Bool
    column :: Int
end
Base.:(==)(x::TableCell, y::TableCell) = (x.align == y.align) && (x.header == y.header) && (x.column == y.column)
can_contain(::TableCell, e::AbstractElement) = isa(e, AbstractInline)

"""
    struct Backslash <: AbstractInline

Represents a backslash character `\\`.
"""
struct Backslash <: AbstractInline end

"""
    struct SoftBreak <: AbstractInline

Represents a soft break which can be rendered as a space instead.
"""
struct SoftBreak <: AbstractInline end

"""
    struct LineBreak <: AbstractInline

Represents a hard line break in a sequence of inline nodes that should lead to a newline
when rendered.
"""
struct LineBreak <: AbstractInline end

"""
    struct JuliaValue <: AbstractInline

Inline leaf element for interpolation of Julia expressions and their evaluated values.
Two `JuliaValue` objects are considered equal if the Julia objects they refer to are equal
(even if they originate from different expressions).

# Fields

* `.ex :: Any`: contains the original Julia expression (e.g. `Expr`, `Symbol`, or some
  literal value)
* `.ref :: Any`: stores the Julia object the expression evaluates to

# Constructors

```julia
JuliaValue(ex, ref = nothing)
```
"""
struct JuliaValue <: AbstractInline
    ex
    ref # TODO: distinguish .ref that is unset and evaluates to `nothing`
    JuliaValue(ex, value = nothing) = new(ex, value)
end
# TODO: should this be === ?
Base.:(==)(x::JuliaValue, y::JuliaValue) = (x.ref == y.ref)

struct InvalidChildException <: Exception
    parent :: AbstractElement
    child :: AbstractElement
end

# These tests depends on all _available_ standard libraries, so we can not run it as
# part of the normal test suite (we'd need to add all the standard libraries as
# dependencies to Project.toml).
using MarkdownAST
using Markdown, Pkg, Test

function list_stdlibs()
    stdlibs = Symbol[]
    for stdlib in readdir(Sys.STDLIB)
        stdlib_path = joinpath(Sys.STDLIB, stdlib)
        isdir(stdlib_path) || continue
        endswith(stdlib, "_jll") && continue
        push!(stdlibs, Symbol(stdlib))
    end
    return stdlibs
end
find_submodules(m::Module) = find_submodules!(Module[], m)
function find_submodules!(submodules::Vector{Module}, m::Module)
    push!(submodules, m)
    for name in names(m, all=true)
        isdefined(m, name) || continue
        sm = getfield(m, name)
        (sm isa Module) && (sm ∉ submodules) && find_submodules!(submodules, sm)
    end
    return submodules
end
function allmodules()
    submodules = find_submodules(Base)
    for stdlib in list_stdlibs()
        Base.eval(@__MODULE__, :(import $stdlib))
        m = Base.invokelatest(getfield, @__MODULE__, stdlib)
        find_submodules!(submodules, m)
    end
    return submodules
end
function moduledocstrings!(mds::Vector{Markdown.MD}, m::Module)
    docmeta = Docs.meta(m)
    for multidoc in values(docmeta)
        for docstr in values(multidoc.docs)
            @assert docstr isa Docs.DocStr
            md = Docs.parsedoc(docstr)
            @assert md isa Markdown.MD
            if length(md.content) == 1 && md.content[1] isa Markdown.MD
                md = md.content[1]
            end
            push!(mds, md)
        end
    end
    return mds
end
function alldocstrings()
    mds = Markdown.MD[]
    for m in allmodules()
        Base.invokelatest(moduledocstrings!, mds, m)
    end
    return mds
end

@testset "Base docstrings" begin
    for md in alldocstrings()
        node = convert(MarkdownAST.Node, md)
        @test node isa MarkdownAST.Node
    end
end

using MarkdownAST: MarkdownAST, @ast, Node,
    Document, Paragraph, Strong, Link, CodeBlock, HTMLBlock, Code,
    InvalidChildException, insert_after!, insert_before!
using Test

@testset "Invalid AST" begin
    # Document can only contain blocks, not inlines
    @test_throws InvalidChildException (@ast Document() do
        Link("", "")
    end)
    valid_document = @ast Document() do
        Paragraph()
    end
    node_strong = Node(Strong())
    @test_throws InvalidChildException push!(valid_document.children, node_strong)
    @test_throws InvalidChildException pushfirst!(valid_document.children, node_strong)
    @test_throws InvalidChildException insert_after!(first(valid_document.children), node_strong)
    @test_throws InvalidChildException insert_before!(first(valid_document.children), node_strong)

    # Paragraph can only contain inlines, but not blocks:
    @test_throws InvalidChildException (@ast Paragraph() do
        HTMLBlock("")
    end)
    valid_p = @ast Paragraph() do
        "..."
    end
    node_codeblock = Node(CodeBlock("", ""))
    @test_throws InvalidChildException push!(valid_p.children, node_codeblock)
    @test_throws InvalidChildException pushfirst!(valid_p.children, node_codeblock)
    @test_throws InvalidChildException insert_after!(first(valid_p.children), node_codeblock)
    @test_throws InvalidChildException insert_before!(first(valid_p.children), node_codeblock)

    # Some nodes can not have child nodes
    @test_throws InvalidChildException (@ast CodeBlock("", "") do
        "..."
    end)
    @test_throws InvalidChildException (@ast Code("...") do
        "..."
    end)
end

using MarkdownAST
using Test

@testset "MarkdownAST" begin
    @test isempty(Test.detect_ambiguities(MarkdownAST; recursive=true))

    include("markdown.jl")
    include("node.jl")
    include("invalidast.jl")
    include("tools.jl")
    include("fromstdlib.jl")
    include("tostdlib.jl")
    include("abstracttrees.jl")
end

using MarkdownAST: MarkdownAST, Node, @ast, Document,
    Emph, Strong, Strikethrough, InlineMath, Link, Code, Image,
    Paragraph, Heading, CodeBlock, BlockQuote, DisplayMath, ThematicBreak,
    List, Item, FootnoteLink, FootnoteDefinition, Admonition,
    Table, TableHeader, TableBody, TableRow, TableCell,
    JuliaValue, LineBreak, HTMLBlock, HTMLInline
using Markdown: Markdown
using Test

@testset "Conversion from Markdown stdlib" begin
    # Helper functions
    @test MarkdownAST.rpad_array!([], 3, 0) == [0, 0, 0]
    @test MarkdownAST.rpad_array!([1], 3, 0) == [1, 0, 0]
    @test MarkdownAST.rpad_array!([1, 2], 3, 0) == [1, 2, 0]
    @test MarkdownAST.rpad_array!([1, 2, 3], 3, 0) == [1, 2, 3]
    @test MarkdownAST.rpad_array!([1, 2, 3, 4], 3, 0) == [1, 2, 3, 4]
    @test MarkdownAST.rpad_array!([], 0, 0) == []
    @test MarkdownAST.rpad_array!([], -2, 0) == []
    @test MarkdownAST.rpad_array!([1], 0, 0) == [1]
    @test MarkdownAST.rpad_array!([1], -2, 0) == [1]

    # Inline elements.
    @test convert(Node, Markdown.md"xyz") == @ast Document() do
        Paragraph() do
            "xyz"
        end
    end

    @test convert(Node, Markdown.md"**xxx** *yyy* _zzz_ `literal` ``latex``") == @ast Document() do
        Paragraph() do
            Strong() do; "xxx"; end
            " "
            Emph() do; "yyy"; end
            " "
            Emph() do; "zzz"; end
            " "
            Code("literal")
            " "
            InlineMath("latex")
        end
    end

    @test convert(Node, Markdown.md"aaa [bbb](url://) ccc ![aaa](url)") == @ast Document() do
        Paragraph() do
            "aaa "
            Link("url://", "") do; "bbb"; end
            " ccc "
            Image("url", "") do; "aaa"; end
        end
    end

    @static if isdefined(Markdown, :Strikethrough)
        @test convert(Node, Markdown.parse("~~xxx~~")) == @ast Document() do
            Paragraph() do
                Strikethrough() do; "xxx"; end
            end
        end
    end

    # Top-level elements
    @test convert(Node, Markdown.md"""
    p1

    # Header 1
    ## Header 2
    ### Header 3
    #### Header 4
    ##### Header 5
    ###### Header 6

    Header 1
    ========
    p2

    Header 2
    --------
    p3
    """) == @ast Document() do
        Paragraph() do; "p1"; end
        Heading(1) do; "Header 1"; end
        Heading(2) do; "Header 2"; end
        Heading(3) do; "Header 3"; end
        Heading(4) do; "Header 4"; end
        Heading(5) do; "Header 5"; end
        Heading(6) do; "Header 6"; end
        Heading(1) do; "Header 1"; end
        Paragraph() do; "p2"; end
        Heading(2) do; "Header 2"; end
        Paragraph() do; "p3"; end
    end

    @test convert(Node, Markdown.md"""
    ```
    code
    ```
    ```lang
    code
    ```
    ```math
    x^2
    ```
    """) == @ast Document() do
        CodeBlock("", "code")
        CodeBlock("lang", "code")
        DisplayMath("x^2")
    end

    @test convert(Node, Markdown.md"""
    foo

    ---

    bar
    """) == @ast Document() do
        Paragraph() do; "foo"; end
        ThematicBreak()
        Paragraph() do; "bar"; end
    end

    @test convert(Node, Markdown.md"""
    foo[^1].

    [^1]: ...
    """) == @ast Document() do
        Paragraph() do
            "foo"
            FootnoteLink("1")
            "."
        end
        FootnoteDefinition("1") do
            Paragraph() do; "..."; end
        end
    end

    @test convert(Node, Markdown.md"""
    1. aaa

    2. bbb

    * aaa
    * bbb
      - ccc
    * ddd
    """) == @ast Document() do
        List(:ordered, false) do
            Item() do; Paragraph() do; "aaa"; end; end
            Item() do; Paragraph() do; "bbb"; end; end
        end
        List(:bullet, true) do
            Item() do; Paragraph() do; "aaa"; end; end
            Item() do
                Paragraph() do; "bbb"; end
                List(:bullet, true) do
                    Item() do; Paragraph() do; "ccc"; end; end
                end
            end
            Item() do; Paragraph() do; "ddd"; end; end
        end
    end
    @test convert(Node, Markdown.md"""
    * Foo

      Bar
    * Baz
    """) == @ast Document() do
        List(:bullet, false) do
            Item() do
                Paragraph() do; "Foo"; end
                Paragraph() do; "Bar"; end
            end
            Item() do; Paragraph() do; "Baz"; end; end
        end
    end

    @test convert(Node, Markdown.md"""
    | Column One | Column Two | Column Three |
    |:---------- | ---------- |:------------:|
    | Row `1`    | Column `2` |              |
    | *Row* 2    | **Row** 2  | Column ``3`` |
    """) == @ast Document() do
        Table([:left, :right, :center]) do
            TableHeader() do
                TableRow() do
                    TableCell(:left, true, 1) do
                        "Column One"
                    end
                    TableCell(:right, true, 2) do
                        "Column Two"
                    end
                    TableCell(:center, true, 3) do
                        "Column Three"
                    end
                end
            end
            TableBody() do
                TableRow() do
                    TableCell(:left, false, 1) do
                        "Row "
                        Code("1")
                    end
                    TableCell(:right, false, 2) do
                        "Column "
                        Code("2")
                    end
                    TableCell(:center, false, 3)
                end
                TableRow() do
                    TableCell(:left, false, 1) do
                        Emph() do
                            "Row"
                        end
                        " 2"
                    end
                    TableCell(:right, false, 2) do
                        Strong() do
                            "Row"
                        end
                        " 2"
                    end
                    TableCell(:center, false, 3) do
                        "Column "
                        InlineMath("3")
                    end
                end
            end
        end
    end

    @test convert(Node, Markdown.md"""
    !!! foo "bar baz"

        xyz
    """) == @ast Document() do
        Admonition("foo", "bar baz") do
            Paragraph() do; "xyz"; end
        end
    end
    @test convert(Node, Markdown.md"""
    !!! foo

        !!! warn "FOOBAR"
            Hello World

            ```math
            x+1
            ```
    """) == @ast Document() do
        Admonition("foo", "Foo") do
            Admonition("warn", "FOOBAR") do
                Paragraph() do; "Hello World"; end
                DisplayMath("x+1")
            end
        end
    end

    # LineBreak, Backslash, SoftBreak
    @test convert(Node, Markdown.md"""
    foo\
    bar
    """) == @ast Document() do
        Paragraph() do
            "foo"
            LineBreak()
            "bar"
        end
    end
    # This would lead to a Backslash() in CommonMark, but not in Markdown
    @test convert(Node, Markdown.md"""
    foo\\\\bar
    """) == @ast Document() do
        Paragraph() do
            "foo"
            "\\"
            "\\"
            "bar"
        end
    end
    # This would lead to a SoftBreak() in CommonMark, but not in Markdown
    let ast = convert(Node, Markdown.md"""
        foo
        bar
        """)
        @test ast in (
            @ast(Document() do
                Paragraph() do
                    "foo bar"  # In Julia 1.14, whitespaces are "normalized"
                end
            end),
            @ast(Document() do
                Paragraph() do
                    "foo\nbar"  # In Julia 1.14, the newline is preserved
                end
            end),
        )
    end

    # Interpolation
    z = 1//2
    @test convert(Node, Markdown.md"""
    Interpolations: $(:foo), $(z), $(abs2(z)), $(2)
    """) == @ast Document() do
        Paragraph() do
            "Interpolations: "
            JuliaValue(nothing, :foo)
            ", "
            JuliaValue(nothing, 1//2)
            ", "
            JuliaValue(nothing, 1//4)
            ", "
            JuliaValue(nothing, 2)
        end
    end
    # interpolated string values are indistinguishable from normal text nodes
    # in the standard library AST
    foo = "foo"
    @test convert(Node, Markdown.md"""
    Interpolations: $("bar"), $(foo)
    """) == @ast Document() do
        Paragraph() do
            "Interpolations: "
            "bar"
            ", "
            "foo"
        end
    end
    # It is possible to have interpolation "blocks" in the standard library
    @test convert(Node, Markdown.md"""
    Block:

    $(123)

    > $(1234)
    """) == @ast Document() do
        Paragraph() do; "Block:"; end
        Paragraph() do
            JuliaValue(nothing, 123)
        end
        BlockQuote() do
            Paragraph() do
                JuliaValue(nothing, 1234)
            end
        end
    end

    # Problematic cases, like manually crafted nodes
    #
    # It is theoretically possible to have inline nodes in block context:
    let m = Markdown.MD()
        push!(m.content, "Foo")
        push!(m.content, Markdown.Link(["text"], "url"))
        @test convert(Node, m) == @ast Document() do
            Paragraph() do
                "Foo"
            end
            Paragraph() do
                Link("url", "") do
                    "text"
                end
            end
        end
    end
    @static if isdefined(Markdown, :HTMLBlock)
        let m = Markdown.MD()
            push!(m.content, Markdown.HTMLBlock(["<div>", "x", "</div>"]))
            @test convert(Node, m) == @ast Document() do
                HTMLBlock("<div>\nx\n</div>")
            end
        end
    end
    @static if isdefined(Markdown, :HTMLInline)
        let m = Markdown.MD()
            push!(m.content, Markdown.Paragraph([Markdown.HTMLInline("<span>x</span>")]))
            @test convert(Node, m) == @ast Document() do
                Paragraph() do
                    HTMLInline("<span>x</span>")
                end
            end
        end
    end

    # Tests from the Documenter Markdown2 module
    let ast = convert(Node, Markdown.parse(raw"""
        $$
        f
        $$
        """))
        @test ast in (
            @ast(Document() do
                Paragraph() do; JuliaValue(nothing, :$); end
                Paragraph() do; "f "; JuliaValue(nothing, :$); end # Julia <= 1.13
            end),
            @ast(Document() do
                Paragraph() do; JuliaValue(nothing, :$); end
                Paragraph() do; "f\n"; JuliaValue(nothing, :$); end # Julia >= 1.14
            end),
        )
    end
    @test convert(Node, Markdown.parse(raw"""
    X $(42) Y
    """)) == @ast Document() do
        Paragraph() do
            "X "
            JuliaValue(nothing, 42)
            " Y"
        end
    end
    @test convert(Node, Markdown.md"""
    #
    """) == @ast Document() do
        Heading(1) do; ""; end
    end

    # Test conversion into nodes with custom metadata
    let md = Markdown.md"xyz"
        @test convert(Node{Nothing}, md) isa Node{Nothing}
        @test_throws MethodError convert(Node{Int}, md)
        @test convert(Node{Vector{Int}}, md) isa Node{Vector{Int}}
        @test convert(Node{Int}, md, () -> 42) isa Node{Int}
        @test_throws TypeError convert(Node{Int}, md, () -> "42") isa Node{Int}
    end
end

# This example demonstrates the conversion from the Markdown standard library AST to the
# MarkdownAST AST representation.
using MarkdownAST: MarkdownAST, Node
using Markdown: @md_str

doc = md"""
# Example document

Lorem ipsum *emphasis here* dolores **strong** amet.

The following tests an empty heading labels:

##

---

> This is a block quote.
>
> This paragraph contains [links](link/url/) and ![images](image.jpeg).

---

> One-line block quote, followed by an empty block quote.

>

Inline mathematics (``x^2``) and display math:

```math
x^2
```

!!! warn "Admonition title"

    Admonition content.

    > Admonitions contain block content.

* Additional AST elements include..
* Autolinks: <https://autolink.com>
* More complex links: [X **Y** Z](url/)
* Footnotes[^footnote]

Tables get converted too:

| Column One | Column Two | Column Three |
|:---------- | ---------- |:------------:|
| Row `1`    | Column `2` |              |
| *Row* 2    | **Row** 2  | Column ``3`` |

[^footnote]: Footnote definition.
"""

# Convert the standard library AST into MarkdownAST
doc_mdast = convert(Node, doc)

# Print the AST into stdout
MarkdownAST.showast(doc_mdast)

module MarkdownAST
import AbstractTrees
import Markdown

include("utilities.jl")
include("markdown.jl")
include("node.jl")
include("tools.jl")
include("astmacro.jl")
include("abstracttrees.jl")
include("stdlib/fromstdlib.jl")
include("stdlib/tostdlib.jl")

# Compat with older Julia versions
#
# isnothing borrowed from Compat.jl (MIT):
# https://github.com/JuliaLang/Compat.jl/blob/3ae185fa45a3091b387b67b6fd8f58f761854238/src/Compat.jl#L72-L77
#
# https://github.com/JuliaLang/julia/pull/29679
if VERSION < v"1.1.0-DEV.472"
    isnothing(::Any) = false
    isnothing(::Nothing) = true
end

end

# This file implements the AbstractTrees interface, which in turns provides such
# functionality like walking over the Markdown trees etc.
AbstractTrees.children(node::Node) = node.children
AbstractTrees.childtype(node::Node) = typeof(node)
AbstractTrees.childrentype(node::Node) = typeof(node.children)

AbstractTrees.ParentLinks(::Type{<:Node}) = AbstractTrees.StoredParents()
AbstractTrees.parent(node::Node) = node.parent

AbstractTrees.SiblingLinks(::Type{<:Node}) = AbstractTrees.StoredSiblings()
AbstractTrees.nextsibling(node::Node) = node.next
AbstractTrees.prevsibling(node::Node) = node.previous

AbstractTrees.nodevalue(node::Node) = node.element

"""
    copy_tree(root::Node)
    copy_tree(f, root::Node)

Creates a copy of the tree, starting from `node` as the root node, and  optionally calling `f`
on each of the nodes to determine the corresponding `.element` in the copied tree.

If `node` is not the root of its tree, its parent nodes are ignored, and the root node of the
copied node corresponds to `node`.

The function `f` should have the signature `(::Node, ::AbstractElement) -> AbstractElement`,
and it gets passed the current node being copied and its element. It must return an instance
of some [`AbstractElement`](@ref), which will then be assigned to the `.element` field of
the copied node. By default, `copy_tree` performs a `deepcopy` of both the element
(`.element`) and the node metadata (`.meta`).

# Extended help

For example, to perform a `copy` instead of `deepcopy` on the elements, `copy_tree` can be
called as follows

```julia
copy_tree((_, e) -> copy(e), node::Node)
```

Note that `copy_tree` does not allow the construction of invalid trees, and element
replacements that require invalid parent-child relationships (e.g. a block element as a child
to an element expecting inlines) will throw an error.
"""
function copy_tree end
function copy_tree(f, root::Node{M}) where M
    new_element = f(root, root.element)
    new_root = Node{M}(new_element, deepcopy(root.meta))
    for child in root.children
        new_child = copy_tree(f, child)
        push!(new_root.children, new_child)
    end
    return new_root
end
copy_tree(root::Node) = copy_tree((_, e) -> deepcopy(e), root)

# Helper functions for Table() elements

"""
    tablerows(node::Node)

Returns an iterable object containing the all the [`TableRow`](@ref) elements of a table,
bypassing the intermediate [`TableHeader`](@ref) and [`TableBody`](@ref) nodes. Requires
`node` to be a [`Table`](@ref) element.

The first element of the iterator should be interpreted to be the header of the table.
"""
function tablerows(node::Node)
    node.element isa Table || error("needs a Table() node")
    Iterators.flatten(child.children for child in node.children)
end

"""
    tablesize(node::Node, [dim])

Similar to `size`, returns the number of rows and/or columns of a [`Table`](@ref) element.
The optional `dim` argument can be passed to return just either the number of rows or columns,
and must be `1` to obtain the number of rows, and `2` to obtain the number of columns.

!!! note "Complexity"

    Determining the number of columns is an ``O(n \\times m)`` operation in the number of rows
    and columns, due to the required traversal of the linked nodes. Determining only the number
    of rows with `tablesize(node, 1)` is an ``O(n)`` operation.
"""
function tablesize end
tablesize(node::Node) = _tablesize(node, true)
function tablesize(node::Node, dim::Integer)
    if dim == 1
        _tablesize(node, false)[1]
    elseif dim == 2
        _tablesize(node, true)[2]
    else
        error("dimension out of range")
    end
end
function _tablesize(node::Node, countcols::Bool)
    node.element isa Table || error("needs a Table() node")
    nrows, ncols = 0, 0
    for row in tablerows(node)
        nrows += 1
        if countcols
            ncols = max(length(row.children), ncols)
        end
    end
    return nrows, ncols
end

struct UnimplementedMethodError <: Exception
    method :: String
    extra :: String
    UnimplementedMethodError(method :: AbstractString, extra :: AbstractString = "") = new(method, extra)
end

function Base.showerror(io::IO, e::UnimplementedMethodError)
    print(io, "UnimplementedMethodError: $(e.method) not implemented")
    isempty(e.extra) || print(io, '\n', e.extra)
end

```@meta
CurrentModule = MarkdownAST
```

# Tree node interface

The Markdown abstract syntax tree (AST) is a tree of [Markdown elements](@ref AbstractElement).
In order to avoid type instabilities when performing basic operations on a tree, such as traversin it, it is implemented by linking together instances of the [`Node`](@ref) type.
Each [`Node`](@ref) instance functions as a container for some [`AbstractElement`](@ref).

The [`Node`](@ref) type has various _properties_ that can be used to access information about the structure of the tree, but it is generally not possible to set them directly.
Changing the structure of a tree (e.g. to adding child nodes), should be done with the help of the [various functions and methods to MarkdownAST provides for mutating the tree](@ref "Mutating the tree").

```@docs
Node
Base.:(==)(::Node{T}, ::Node{T}) where T
```

## Accessing child nodes

Internally, to store the children, a node simply stores the reference to the first and the last child node, and each child stores the references to the next and previous child.
The `.children` property is implemented simply as a lazy iterator of type [`NodeChildren`](@ref) that traverses the linked list.
As such, some operations, such as determining the number of children a node has with [`length`](@ref Base.length(::NodeChildren)), can have unexpected ``O(n)`` complexity.

```@docs
haschildren
NodeChildren
Base.eltype(::Type{NodeChildren{T}}) where T
Base.length(::NodeChildren)
Base.isempty(::NodeChildren)
#Base.first(::NodeChildren{T}) where T
#Base.last(::NodeChildren{T}) where T
```
```@autodocs
Modules = [MarkdownAST]
Filter = t -> t in [Base.first, Base.last]
```

## Mutating the tree

The following functions and methods can be used to mutate the Markdown AST trees represented using [`Node`](@ref) objects.
When using these methods, the consistency of the tree is preserved (i.e. the references between the affected nodes are correctly updated).
Changing the structure of the tree in any other way should generally be avoided, since the code that operates on trees generally assumes a consistent tree, and will likely error or behave in unexpected ways on inconsistent trees.

!!! warning "Mutating the tree while traversing"

    Mutating the structure of the tree while traversing it with some iterator (e.g. `.children` or one of the [AbstractTrees iterators](@ref "Iteration over trees")) can lead to unexpected behavior and should generally be avoided.
    Updating the `.element` of a node while traversing, on the other hand, is fine. In general, [`replace!`](@ref) can be used to mutate a tree in arbitrary ways.

```@docs
Base.replace(::Function, ::T) where {T <: Node}
Base.replace!(::Function, ::Node)
unlink!
insert_before!
insert_after!
Base.push!(::NodeChildren{T}, ::T) where {T <: Node}
Base.pushfirst!(::NodeChildren{T}, ::T) where {T <: Node}
Base.append!(::NodeChildren{T}, ::Any) where T
Base.prepend!(::NodeChildren{T}, ::Any) where T
Base.empty!(::NodeChildren)
```

!!! note "Mutating the .children property"

    The choice to apparently mutate the `.children` property when adding child nodes is purely syntactic, and in reality the operation affects the parent [`Node`](@ref) object.
    Internally the `.children` iterator is simply a thin wrapper around the parent node.

## Copying trees

The [`copy_tree`](@ref) function can be used to easily copy a tree.

```@docs
copy_tree
```

This can be particularly useful in circumstances where a tree is passed to other code that while processing the tree also mutates it.
As [`Node`](@ref) is a mutable type, this means that the original tree also mutates.
Passing the result from [`copy_tree`](@ref) can be used to avoid that issue.

## Index

```@index
Pages = ["node.md"]
```

# MarkdownAST

The structure of a Markdown file can be represented as an [abstract syntax tree](https://en.wikipedia.org/wiki/Abstract_syntax_tree).
The MarkdownAST package defines a Julia interface for representing such trees to facilitate the interoperability between different packages that deal with Markdown documents in different ways.

While the primary goal is to represent Markdown documents, the tree structure, implemented by the [`Node`](@ref MarkdownAST.Node) type and the [`AbstractElement`](@ref MarkdownAST.AbstractElement) subtypes, is intentionally generic and can also be used to represent more general documents.

# Iteration over trees

The [`Node`](@ref MarkdownAST.Node) type implements the [AbstractTrees](https://github.com/JuliaCollections/AbstractTrees.jl) interface which provides various general tree-iteration algorithms.

Using the following MarkdownAST tree as an example:

```@setup iter
using MarkdownAST: @ast, Document, Heading, Paragraph, Strong, CodeBlock
```

```@example iter
md = @ast Document() do
    Heading(1) do; "Iteration example"; end
    Paragraph() do
        "MarkdownAST trees can be iterated over with "
        Strong() do; "AbstractTrees"; end
        "."
    end
    Paragraph() do; "To use it, load the package with"; end
    CodeBlock("julia", "using AbstractTrees")
end
nothing # hide
```

The different [AbstractTrees iterators](https://juliacollections.github.io/AbstractTrees.jl/stable/iteration/), such as `PostOrderDFS`, `PreOrderDFS`, or `Leaves`, can be used to construct iterators from the `md` variable (which is an instance of [`Node`](@ref MarkdownAST.Node)).
Each algorithm provides a way to iterate through the trees in a different way, as can be seen in the following examples:

```@example iter
using AbstractTrees
for node in PostOrderDFS(md)
    println(node.element)
end
```

```@example iter
for node in PreOrderDFS(md)
    println(node.element)
end
```

```@example iter
using AbstractTrees
for node in Leaves(md)
    println(node.element)
end
```

# Constructing trees

The [`@ast` macro](@ref MarkdownAST.@ast) can be used to construct complex trees with relatively little effort, without having to construct and push all the [`Node`](@ref MarkdownAST.Node) instances yourself.

```@docs
MarkdownAST.@ast
```

```@meta
CurrentModule = MarkdownAST
```

# Conversion to and from `Markdown` standard library

The [`Markdown` standard library](https://docs.julialang.org/en/v1/stdlib/Markdown/) in Julia provides an alternative representation of the Markdown AST.
In particular, the parser and AST there is internally used by Julia for docstrings, and is also used by some of the tooling in the Julia ecosystem that deals with Markdown.

MarkdownAST supports bi-directional conversion between the two AST representations via the `convert` function.
The conversion, however, is not perfect since there are differences in what and how the two libraries represent the Markdown AST.

## Conversion from standard library representation

Any AST that is produced by the `Markdown` standard library parser should parse into MarkdownAST AST.
However, as the data structures for the elements in `Markdown` are pretty loose in what they allow, user-crafted `Markdown` ASTs may error if it does not exactly follow the conventions of the `Markdown` parser.

```@docs
Base.convert(::Type{Node}, md::Markdown.MD)
```

Due to the differences between the Markdown representations, the following things should be kept in mind when converting from the standard library AST into MarkdownAST representation:

- The standard library parser does not have a dedicated type for representing backslashes, and instead stores them as separate single-character text nodes containing a backslash (i.e. `"\\"`).
- Soft line breaks are ignored in the standard library parser and represented with a space instead.
- Strings (or `Markdown` elements) interpolated into the standard library Markdown (e.g. in docstrings or with the `@md_str` macro) are indistinguishable from text (or corresponding Markdown) nodes in the standard library AST, and therefore will not be converted into [`JuliaValue`s](@ref JuliaValue).
- The standard library allows for block-level interpolation. These get converted into inline [`JuliaValue`s](@ref JuliaValue) wrapped in a [`Paragraph`](@ref) element.
- In case the standard library AST contains any inline nodes in block context (e.g. as children for `Markdown.MD`), the get wrapped in a [`Paragraph`](@ref) element too.
- When converting a `Markdown.Table`, the resulting table will be normalized, such as adding empty cells to rows, to make sure that all rows have the same number of cells.
- For links and images, the `.title` attribute is set to an empty string, since the standard library AST does not support parsing titles.
- On Julia 1.14 and newer, `Markdown.HTMLBlock` values are converted to [`HTMLBlock`](@ref) elements. On older Julia versions, such nodes do not exist in the standard library AST.
- On Julia 1.14 and newer, `Markdown.HTMLInline` values are converted to [`HTMLInline`](@ref) elements. On older Julia versions, such nodes do not exist in the standard library AST.

## Conversion to standard library representation

Any AST that contains only [the native MarkdownAST elements](@ref "Markdown AST elements") can be converted into the standard library representation.
The conversion of user-defined elements, however, is not supported and will lead to an error.

```@docs
Base.convert(::Type{Markdown.MD}, node::Node)
```

Due to the differences between the Markdown representations, the following things should be kept in mind when converting from the MarkdownAST representation into the standard library AST:

- The value from a [`JuliaValue`](@ref) element (i.e. `.ref`) gets stored directly in the AST (just like variable interpolation with docstrings and the `@md_str` macro). This means that, for example, an interpolated string or `Markdown` element would become a valid AST element, losing the information that it used to be interpolated.
- The expression information in a [`JuliaValue`](@ref) element (i.e. the `.ex` field) gets discarded.
- The `.title` attribute of [`Link`](@ref) and [`Image`](@ref) elements gets discarded.
- The standard library does not support storing the child nodes of [`Image`](@ref) elements (i.e. "alt text", `![alt text]()`) as AST, and it is instead reduced to a string with the help of the `Markdown.plain` function.
- The standard library AST does not have dedicated elements for [`SoftBreak`](@ref) and [`Backslash`](@ref), and these get converted into strings (i.e. text elements) instead.
- On Julia 1.14 and newer, [`HTMLBlock`](@ref) elements are converted into `Markdown.HTMLBlock`. On older Julia versions they are converted into `Markdown.Code("html", ...)`.
- On Julia 1.14 and newer, [`HTMLInline`](@ref) elements are converted into `Markdown.HTMLInline`. On older Julia versions they are converted into `Markdown.Code("", ...)`.

## Index

```@index
Pages = ["stdlib.md"]
```

```@meta
CurrentModule = MarkdownAST
```

# Markdown AST elements

Every node in the Markdown abstract syntax tree (AST) is associated with an _element_[^1], providing semantic information to the node (e.g. that the node is a paragraph, or a inline code snippet).
In MarkdownAST, each element is an instance of some subtype of [`AbstractElement`](@ref), and may (but does not have to) have fields that contain additional information about how to interpret the element (e.g. the language tag of a code block).

```@docs
AbstractElement
```

If an element does contain some fields, it is usually a mutable type so that it would be possible to update it.

When the Markdown AST is represented using [`Node`s](@ref MarkdownAST.Node), the corresponding elements can be accessed via the `.element` field.

[^1]: This terminology mirrors how each node of the HTML DOM tree is some HTML element.

## Block and inline nodes

In the Markdown AST, the elements can, broadly, be divided into two categories: block and inline elements.
The block elements represent the main, top-level structural elements of a document (e.g. paragraphs, headings, block quotes), whereas inline elements represent components of a paragraph (e.g. bold or plain text, inline math or code snippets).
In MarkdownAST, every block and inline element is a subtype of [`AbstractBlock`](@ref) and [`AbstractInline`](@ref), respectively.

```@docs
AbstractBlock
AbstractInline
isblock
isinline
```

## Constraints on children

As the AST is a tree, nodes (or elements) can have other nodes or elements as children.
However, it does not generally make sense for a node to have arbitrary nodes as children.
For this purpose, there are methods to ensure

First, for some elements it does not make sense for them to have any children at all (i.e. they will always be _leaf_ nodes).
Whether or not an node is a _container_ node (i.e. whether or not it can have other elements as children) is determined by the [`iscontainer`](@ref) function.

```@docs
iscontainer
```

However, a more fine-grained control over the allowed child nodes is often necessary.
For example, while a paragraph can have child nodes, it does not make sense for a paragraph to have another paragraph as a child node, and in fact it should only have inline nodes as children.
Such relationships are defined by the [`can_contain`](@ref) function (e.g. for a [`Paragraph`](@ref) it only returns `true` if the child element is an [`AbstractInline`](@ref)).

```@docs
can_contain
```

Usually, the constraint is whether a container node can contain only block elements or only inline elements.

!!! note

    Sometimes it might be desireable to have even more sophisticated constraints on the elements (e.g. perhaps two elements are not allowed to directly follow each other as children of another node).
    However, it is not practical to over-complicate the APIs here, and simply restricting the child elements of another element seems to strike a good balance.

    Instead, in cases where it becomes possible to construct trees that have questionable semantics due to a weird structure that can not be restricted with [`can_contain`](@ref), the elements should carefully document how to interpret such problematic trees (e.g. how to interpret a table that has no rows and columns).

## CommonMark elements

The [CommonMark specification](https://spec.commonmark.org/) specifies a set of block and inline nodes that can be used to represent Markdown documents.

```@docs
Backslash
BlockQuote
Code
CodeBlock
Emph
HTMLBlock
HTMLInline
Heading
Image
Item
LineBreak
Link
List
Paragraph
SoftBreak
Strong
Strikethrough
Text
ThematicBreak
```

## Julia extension elements

The Julia version of Markdown contains additional elements that do not exists in the CommonMark specification (such as tables or math).
However, as MarkdownAST is meant to be interoperable with the `Markdown` standard library parser, it also supports additional elements to accurately represent the Julia Flavored Markdown documents.

```@docs
Admonition
DisplayMath
FootnoteDefinition
FootnoteLink
InlineMath
JuliaValue
```

### Tables

Tables are build up from the following elements: [`Table`](@ref), [`TableBody`](@ref), [`TableCell`](@ref), [`TableHeader`](@ref), [`TableRow`](@ref).

```@docs
Table
TableBody
TableCell
TableHeader
TableRow
```

In addition, to help with the complexity of the table structure, the following helper functions can be used when working with [`Table`](@ref) elements.

```@docs
tablerows
tablesize
```

## Other elements

[`Document`](@ref) is the root element of a Markdown document.

```@docs
Document
```

## Index

```@index
Pages = ["elements.md"]
```
